<?php
/**
 * @package Admin
 * @todo    Settings page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit();
}

global $wpdb;
$countries = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}whmpress_countries` ORDER BY `country_name`");
$WHMP = new WHMPress;
$currencies = $WHMP->get_currencies();

$newTR = "<tr>";
$newTR .= '<td><select name="whmp_countries_currencies[country][]">';
$newTR .= '<option value="">-- Select Country --</option>';
foreach($countries as $country):
    $newTR .= '<option value="'.$country->country_code.'">'.$country->country_name.'</option>';
endforeach;
$newTR .= '</select>';
$newTR .= '</td>';
$newTR .= '<td>';
$newTR .= '<select name="whmp_countries_currencies[currency][]">';
$newTR .= '<option value="">-- Currency --</option>';
foreach($currencies as $currency):
    $newTR .= '<option value="'.$currency["id"].'">'.$currency["code"].'</option>';
endforeach;
$newTR .= '</select> ';
$newTR .= '[<a title="Remove this country" href="javascript:;" onclick="Remove(this)">X</a>]';
$newTR .= '</td>';
$newTR .= '</tr>';
$newTR = str_replace('"', "'", $newTR);

global $wpdb; ?>


<div class="full_page_loader">
    <div class="whmp_loader"><?php _e("Loading", "whmpress") ?>...</div>
</div>
<div class="wrap">
<div class="whmp-main-title"><span class="whmp-title">WHMpress</span> <?php _e("Settings", "whmpress") ?></div>

<?php if (!WHMPress::WHMpress_synced()): ?>
    
<div class="error">
    <p>
    <b>WHMPress <?php _e("Error", "whmpress") ?></b>
    <?php _e("WHMCS is not Synced", "whmpress") ?> <a href="admin.php?page=whmp-sync"><?php _e("Please Sync WHMCS", "whmpress") ?></a>.
    </p>
</div>

<?php else: ?>

<?php if (isset($_GET["settings-updated"]) && $_GET["settings-updated"]=="true") echo "<div class='updated'><p><b>Success</b><br />Settings saved.</p></div>"; ?>

<form method="post" action="options.php"> 
<?php settings_fields( 'whmp_settings' );
do_settings_sections( 'whmp_settings' ); ?>

<ul class='tabs'>
    <li><a href='#general'><?php _e("General", "whmpress") ?></a></li>
    <li><a href="#styles"><?php _e("Styles", "whmpress") ?></a></li>
    <?php if (function_exists('whmpress_domain_search_ajax_function')): ?>
    <li><a href="#ajax_domain_search"><?php _e("Domain Search", "whmpress") ?></a></li>
    <?php endif; ?>
    <li><a href="#defaults"><?php _e("Default Values", "whmpress") ?></a></li>
    <li><a href="#currencies"><?php _e("Currencies", "whmpress") ?></a></li>
    <li><a href="#3rdparty"><?php _e("3rd Party", "whmpress") ?></a></li>
    <li><a href="#advanced"><?php _e("Advanced", "whmpress") ?></a></li>
    <li><a href="#registration"><?php _e("Registration", "whmpress") ?></a></li>
</ul>

<div id="general">

<table class="form-table">
    <tr>
        <td colspan="2">
        <div class="error">
        <p>
        <?php _e("If you have SSL URL configured in WHMCS Admin Area > Setup > General Settings then you must select HTTPS from here, Or you will endup with redirect loop.", "whmpress"); ?>
</p></div>
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;"><?php _e("WHMCS URL", "whmpress") ?></td>
        <td>
        <?php
        $Q = "SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='SystemURL' OR `setting`='SystemSSLURL' ORDER BY `setting` DESC";
        $Us = $wpdb->get_results($Q,ARRAY_A); ?>
        <select style="width:100%;" name="whmcs_url">
            <?php foreach($Us as $U):
                if (whmp_get_installation_url()==$U["value"]) {
                    $S = "selected=selected";
                } else $S = ""; ?>
            <option <?php echo $S ?>><?php echo $U["value"] ?></option>
            <?php endforeach; ?>
        </select>
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;"><?php _e("Decimal Seperator", "whmpress") ?></td>
        <td>
        <input style="width:100%;" name="decimal_replacement" value="<?php echo esc_attr( get_option('decimal_replacement',".") ); ?>">
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;"><?php _e("Show trailing zeros in price", "whmpress") ?></td>
        <td>
        <?php $dz = esc_attr( get_option('show_trailing_zeros',"no") ); ?>
        <select style="width:100%;" name="show_trailing_zeros">
            <option value="no"><?php _e("No", "whmpress") ?></option>
            <option value="yes" <?php echo $dz=="yes"?"selected=selected":""; ?>><?php _e("Yes", "whmpress") ?></option>
        </select>
        </td>
    </tr>
    <tr valign="top">
        <td scope="row" style="width:30%;"><?php _e("Show symbol with price", "whmpress") ?></td>
        <td>
        <?php $symb = esc_attr( get_option('default_currency_symbol',"prefix") ); ?>
        <select style="width:100%;" name="default_currency_symbol">
            <option value="prefix"><?php _e("Prefix", "whmpress") ?></option>
            <option value="suffix" <?php echo $symb=="suffix"?"selected=selected":""; ?>><?php _e("Suffix", "whmpress") ?></option>
            <option value="code" <?php echo $symb=="code"?"selected=selected":""; ?>><?php _e("Code", "whmpress") ?></option>
            <option value="none" <?php echo $symb=="none"?"selected=selected":""; ?>><?php _e("None", "whmpress") ?></option>
        </select>
        </td>
    </tr>
    <tr>
        <td>&nbsp;</td>
        <td><?php submit_button(); ?></td>
    </tr>
</table>
</div>

<div id="styles">
    <table class="form-table">
        <tr scope="row">
            <td style="width:30%;"><?php _e("Select style", "whmpress") ?></td>
            <td>
                <select name="whmp_custom_css">
                    <?php $theme_files = glob(WHMP_PLUGIN_DIR."/styles/*.css");
                    if (is_array($theme_files)) foreach($theme_files as $theme_file):
                    $S = whmpress_get_option("whmp_custom_css")==basename($theme_file)?"selected=selected":""; ?>
                    <option <?php echo $S ?>><?php echo basename($theme_file) ?></option>
                    <?php endforeach; ?>
                </select>
            </td>
        </tr>
        <tr valign="top">
            <td scope="row" style="width:30%;"><?php _e("Load matching css/templates from", "whmpress") ?></td>
            <td>
                <select name="load_sytle_orders">
                    <option value="">No Matching Templates</option>
                    <option <?php echo get_option("load_sytle_orders")=="author"?"selected=selected":"" ?> value="author">Matching Templates by Theme Author</option>
                    <option <?php echo get_option("load_sytle_orders")=="whmpress"?"selected=selected":"" ?> value="whmpress">Matching Templates by WHMpress</option>
                </select>
            </td>
        </tr>
        <tr scope="row">
            <td valign="top" style="width:30%;"><?php _e("Include font awesome", "whmpress") ?></td>
            <td>
                <select name="include_fontawesome">
                    <option value="0"><?php _e("No", "whmpress") ?></option>
                    <option value="1" <?php echo get_option('include_fontawesome')=="1"?"selected=selected":"" ?>><?php _e("Yes", "whmpress") ?></option>
                </select><br />
                <span style="color: #CC0000;">
                <b>Note:</b> <a href="http://fontawesome.io/icons/" target="_blank">FontAwesome</a> is font icons library, which is used by our "Pricing Table Groups". If your theme doesn't include FontAwesome then you can use FontAwesome.
                </span>
            </td>
        </tr>
        <tr scope="row">
            <td valign="top" style="width:30%;"><?php _e("Custom CSS codes", "whmpress") ?></td>
            <td>
                <textarea style="width: 100%; height:200px" name="whmp_custom_css_codes"><?php echo esc_attr(whmpress_get_option("whmp_custom_css_codes")); ?></textarea>
            </td>
        </tr>
        <tr>
            <td></td>
            <td><?php submit_button(); ?></td>
        </tr>
    </table>
</div>

<?php if (function_exists('whmpress_domain_search_ajax_function')): ?>
<div id="ajax_domain_search">
    <div class="settings-wrap">
        <div class="settings-nav">
            <div class="mainnav contextual-help-tabs hide-if-no-js">
        		<ul>
                    <li><a href="#SearchOptions" class="nav-general"><?php _e("Search Options", "whmpress") ?></a></li>
                    <li><a href="#CustomMessages" class="nav-general"><?php _e("Custom Messages", "whmpress") ?></a></li>
                    <li><a href="#WhoIsServers" class="nav-general"><?php _e("WhoIs Servers", "whmpress") ?></a></li>
                    
                </ul>
    		</div>
        </div>
        
        <div class="settings-tabs">
            <div class="tab"><h3>&nbsp;</h3></div>
            
            <div id="tab-SearchOptions" class="tab">
                <h3><?php _e("Search Options", "whmpress") ?></h3>
                <table class="form-table">
                    <tr valign="top">
                        <td style="width:30%;" scope="row"><?php _e("Enable logs for searches", "whmpress") ?></td>
                        <td>
                            <select name="enable_logs">
                                <option value="0">No</option>
                                <option value="1" <?php echo get_option('enable_logs')=="1"?"selected=selected":""; ?>>Yes</option>
                            </select>
                        </td>
                    </tr>
                    <tr valign="top">
                        <td style="width:30%;" scope="row"><?php _e("Number of domains to show in load more page", "whmpress") ?></td>
                        <td><input type="number" style="width:100%;" name="no_of_domains_to_show" value="<?php echo esc_attr( get_option('no_of_domains_to_show','10') ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("TLD orders, (Comma seprated)", "whmpress") ?></td>
                        <td><textarea style="width:100%;" rows="5" name="tld_order"><?php echo esc_attr( get_option('tld_order') ); ?></textarea></td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-CustomMessages" class="tab">
                <h3><?php _e("Custom Messages", "whmpress") ?></h3>
                <table class="form-table">
                    <tr valign="top">
                        <td style="width:30%;" scope="row"><?php _e("Domain available message", "whmpress") ?></td>
                        <td><input style="width:100%;" name="domain_available_message" value="<?php echo esc_attr( get_option('domain_available_message') ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Domain not available message", "whmpress") ?></td>
                        <td><input style="width:100%;" name="domain_not_available_message" value="<?php echo esc_attr( get_option('domain_not_available_message') ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Recommended domains list message", "whmpress") ?></td>
                        <td><input style="width:100%;" name="domain_recommended_list" value="<?php echo esc_attr( get_option('domain_recommended_list') ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Ongoing domain available message", "whmpress") ?></td>
                        <td><input style="width:100%;" name="ongoing_domain_available_message" value="<?php echo esc_attr( get_option('ongoing_domain_available_message',__("[domain-name] is available","whmpress") ) ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Ongoing domain not available message", "whmpress") ?></td>
                        <td><input style="width:100%;" name="ongoing_domain_not_available_message" value="<?php echo esc_attr( get_option('ongoing_domain_not_available_message',__("[domain-name] is registered","whmpress") ) ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Register domain button text", "whmpress") ?></td>
                        <td><input style="width:100%;" name="register_domain_button_text" value="<?php echo esc_attr( get_option('register_domain_button_text',__("Select", "whmpress") ) ); ?>" /></td>
                    </tr>
                    <tr valign="top">
                        <td scope="row"><?php _e("Load more button text", "whmpress") ?></td>
                        <td><input style="width:100%;" name="load_more_button_text" value="<?php echo esc_attr( get_option('load_more_button_text',__("Load More", "whmpress")) ); ?>" /></td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-WhoIsServers" class="tab">
                <h3><?php _e("WhoIs Servers", "whmpress") ?></h3>
                
                <table class="form-table">
                    <tr>
                        <td style="width:30%;" scope="row"><?php _e("WhoIs Servers", "whmpress") ?></td>
                        <td>
                            <textarea style="width:100%;" rows="15" name="whois_db"><?php echo whmpress_get_option('whois_db'); ?></textarea>
                        </td>
                    </tr>
                    <tr>
                        <td></td>
                        <td><?php submit_button(); ?></td>
                    </tr>
                </table>
            </div>
            
            <p class="submitbutton">
    			<input type="submit" class="submit-form button-primary" value="Save Changes" />
    		</p>
        </div>
    </div>
</div>

<?php endif; ?>

<style>
#price table tr th {
    text-align:right;
}
</style>
<div id="defaults">
    <div class="settings-wrap">
        <div class="settings-nav">
    		<div class="mainnav contextual-help-tabs hide-if-no-js">
        		<ul>
                    <li><a href="#Price1" class="nav-general">Price</a></li>
                    <li><a href="#DomainPrice1" class="nav-general">Domain Price</a></li>
                    <li><a href="#PriceMatrix" class="nav-general">Price Matrix</a></li>
                    <li><a href="#PriceMatrixDomain" class="nav-general">Price Matrix Domain</a></li>
                    <li><a href="#Combo1" class="nav-general">Order Combo</a></li>
                    <li><a href="#OrderButton" class="nav-general">Order Button</a></li>
                    <li><a href="#PricingTable" class="nav-general">Pricing Table</a></li>
                    <li><a href="#DomainSearch" class="nav-general">Domain Search</a></li>
                    <li><a href="#DomainSearchAjax" class="nav-general">Domain Search Ajax</a></li>
                    <li><a href="#DomainSearchAjaxResult" class="nav-general">Domain Search Ajax Result</a></li>
                    <li><a href="#DomainSearchBulk" class="nav-general">Domain Search Bulk</a></li>
                    <li><a href="#DomainWhoIS" class="nav-general">Domain WhoIS</a></li>
                    <li><a href="#OrderLink" class="nav-general">Order Link</a></li>
                    <li><a href="#Description" class="nav-general">Description</a></li>
                </ul>
    		</div>
    	</div>
        <div class="settings-tabs">
            <div class="tab"><h3>&nbsp;</h3></div>
            <div style="float: right;">Select a panel from left.</div>
            
            <div id="tab-Price1" class="tab">
                <h3><?php _e("Price", "whmpress") ?></h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Billing cycle", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('billingcycle');
                            $data = array("monthly"=>"Monthly",
                                "annually"=>"Annually",
                                "quarterly"=>"Quarterly",
                                "semiannually"=>"Semi Annually",
                                "biennially"=>"Biennially",
                                "triennially"=>"Triennially");
                            echo whmpress_draw_combo($data,$selected,"billingcycle");
                            ?>
                            
                            <span class="description">Select default billing cycle for price</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Hide decimals", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('hide_decimal');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"hide_decimal");
                            ?>
                            
                            <span class="description">Hide/Show decimals with price</span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Decimals", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('decimals');
                            $data = array(0,1,2,3);
                            echo whmpress_draw_combo($data,$selected,"decimals");
                            ?>
                            
                            <?php
                            $selected = whmpress_get_option('decimals_tag');
                            $data = array(
                                "" => "==No Tag==",
                                "b" => "Bold",
                                "i" => "Italic",
                                "u" => "Underline",
                                "sup" => "Superscript",
                                "sub" => "Subscript"
                            );
                            echo whmpress_draw_combo($data,$selected,"decimals_tag");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show prefix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('prefix');
                            $data = array(
                                "No" => "Do not show",
                                "Yes" => "Show prefix",
                                "b" => "Bold tag",
                                "i" => "Italic tag",
                                "u" => "Underline tag",
                                "sup" => "Superscript tag",
                                "sub" => "Subscript tag"
                            );
                            echo whmpress_draw_combo($data,$selected,"prefix");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show suffix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('suffix');
                            $data = array(
                                "No" => "Do not show",
                                "Yes" => "Show suffix",
                                "b" => "Bold tag",
                                "i" => "Italic tag",
                                "u" => "Underline tag",
                                "sup" => "Superscript tag",
                                "sub" => "Subscript tag"
                            );
                            echo whmpress_draw_combo($data,$selected,"suffix");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show duration", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('show_duration');
                            $data = array(
                                "No" => "Do not show",
                                "Yes" => "Show duration",
                                "b" => "Bold tag",
                                "i" => "Italic tag",
                                "u" => "Underline tag",
                                "sup" => "Superscript tag",
                                "sub" => "Subscript tag"
                            );
                            echo whmpress_draw_combo($data,$selected,"show_duration");
                            ?>
                            
                            <?php
                            $selected = whmpress_get_option('show_duration_as');
                            $data = array("loing"=>__("Long Duration (Year)","whmpress"),"short"=>__("Short Duration (Yr)","whmpress"));
                            echo whmpress_draw_combo($data,$selected,"show_duration_as");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Price/Setup", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('price_type');
                            $data = array("price"=>"Price","setup"=>"Setup Fee","total"=>"Price + Setup Fee");
                            echo whmpress_draw_combo($data,$selected,"price_type");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Convert price into monthly price", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('convert_monthly');
                            $data = array("0"=>"No","1"=>"Yes");
                            echo whmpress_draw_combo($data,$selected,"convert_monthly");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Calculate configurable options", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('configureable_options');
                            $data = array("0"=>"No","1"=>"Yes");
                            echo whmpress_draw_combo($data,$selected,"configureable_options");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("String for config price", "whmpress") ?></th>
                        <td>
                            <input name="config_option_string" value="<?php echo esc_attr( whmpress_get_option('config_option_string') ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Price/Tax", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('price_tax');
                            $data = array("default"=>"WHMCS Default","inclusive"=>"Inclusive Tax","exclusive"=>"Exclusive Tax","tax"=>"Tax Only");
                            echo whmpress_draw_combo($data,$selected,"price_tax");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Currency", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('price_currency');
                            $data = array("0"=>"Default");
                            foreach($currencies as $cur) {
                                $data[ $cur["id"] ] = $cur["code"];
                            }
                            echo whmpress_draw_combo($data,$selected,"price_currency");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainPrice1" class="tab">
                <h3><?php _e("Domain Price", "whmpress") ?></h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Type", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_type');
                            $data = array("domainregister"=>"Domain Registration","domainrenew"=>"Domain Renew","domaintransfer"=>"Domain Transfer");
                            echo whmpress_draw_combo($data,$selected,"dp_type");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Years", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_years');
                            $data = array(); for($x=1; $x<=10; $x++) $data[] = $x;
                            echo whmpress_draw_combo($data,$selected,"dp_years");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Decimals", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_decimals');
                            $data = array(); for($x=1; $x<=4; $x++) $data[] = $x;
                            echo whmpress_draw_combo($data,$selected,"dp_decimals");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Hide Decimals", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_hide_decimal');
                            $data = array("No", "Yes");
                            echo whmpress_draw_combo($data,$selected,"dp_hide_decimal");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Decimals As", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_decimals_tag');
                            $data = array(""=>"-- No Tag --","b"=>"Bold","i"=>"Italic","u"=>"Underline","sup"=>"Superscript","sub"=>"Subscript");
                            echo whmpress_draw_combo($data,$selected,"dp_decimals_tag");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Currency Prefix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_prefix');
                            $data = array("Yes"=>"Yes","No"=>"Do not show prefix","b"=>"Bold","i"=>"Italic","u"=>"Underline","sup"=>"Superscript","sub"=>"Subscript");
                            echo whmpress_draw_combo($data,$selected,"dp_prefix");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Currency Suffix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_suffix');
                            $data = array("Yes"=>"Yes","No"=>"Do not show prefix","b"=>"Bold","i"=>"Italic","u"=>"Underline","sup"=>"Superscript","sub"=>"Subscript");
                            echo whmpress_draw_combo($data,$selected,"dp_suffix");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show number of years", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_show_duration');
                            $data = array("Yes"=>"Yes","No"=>"Do not show duration","b"=>"Bold","i"=>"Italic","u"=>"Underline","sup"=>"Superscript","sub"=>"Subscript");
                            echo whmpress_draw_combo($data,$selected,"dp_show_duration");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Price/Tax", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dp_price_tax');
                            $data = array("default"=>"WHMCS Default","inclusive"=>"Inclusive Tax","exclusive"=>"Exclusive Tax","tax"=>"Tax Only");
                            echo whmpress_draw_combo($data,$selected,"dp_price_tax");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-Combo1" class="tab">
                <h3>Combo</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row">Show duration</td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_billingcycles');
                            $data = array("monthly"=>"Monthly",
                                "annually"=>"Annually",
                                "quarterly"=>"Quarterly",
                                "semiannually"=>"Semi Annually",
                                "biennially"=>"Biennially",
                                "triennially"=>"Triennially");
                            echo whmpress_draw_combo_multiple($data,$selected,"combo_billingcycles");
                            ?>
                            <span class="description"><?php _e("Press {Ctrl} button for multiple selection", "whmpress") ?></span>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Decimals", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_decimals');
                            $data = array(0,1,2,3);
                            echo whmpress_draw_combo($data,$selected,"combo_decimals");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show button", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_show_button');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"combo_show_button");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_button_text');
                            ?>
                            <input name="combo_button_text" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show discount", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_show_discount');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"combo_show_discount");
                            
                            $selected = whmpress_get_option('combo_discount_type');
                            $data = array("yearly"=>"%age","monthly"=>"Monthly");
                            echo whmpress_draw_combo($data,$selected,"combo_discount_type");                
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show prefix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_prefix');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"combo_prefix");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show suffix", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('combo_suffix');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"combo_suffix");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-OrderButton" class="tab">
                <h3>Order Button</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Billing Cycle", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ob_billingcycle');
                            $data = array("monthly"=>"Monthly",
                                "annually"=>"Annually",
                                "quarterly"=>"Quarterly",
                                "semiannually"=>"Semi Annually",
                                "biennially"=>"Biennially",
                                "triennially"=>"Triennially");
                            echo whmpress_draw_combo($data,$selected,"ob_billingcycle");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ob_button_text');
                            ?>
                            <input name="ob_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-PricingTable" class="tab">
                <h3>Pricing Box / Pricing Table</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Billing Cycle", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pt_billingcycle');
                            $data = array("monthly"=>"Monthly",
                                "annually"=>"Annually",
                                "quarterly"=>"Quarterly",
                                "semiannually"=>"Semi Annually",
                                "biennially"=>"Biennially",
                                "triennially"=>"Triennially");
                            echo whmpress_draw_combo($data,$selected,"pt_billingcycle");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Price", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pt_show_price');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"pt_show_price");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Combo", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pt_show_combo');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"pt_show_combo");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Button", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pt_show_button');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"pt_show_button");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pt_button_text');
                            ?>
                            <input name="pt_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainSearch" class="tab">
                <h3>Domain Search</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Show Combo", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ds_show_combo');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"ds_show_combo");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Placeholder", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ds_placeholder');
                            ?>
                            <input name="ds_placeholder" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button Text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ds_button_text');
                            ?>
                            <input name="ds_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainSearchAjax" class="tab">
                <h3>Domain Search Ajax</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Placeholder", "whmpress") ?></th>
                        <td>
                            <?php $selected = whmpress_get_option('dsa_placeholder'); ?>
                            <input name="dsa_placeholder" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button Text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_button_text');
                            ?>
                            <input name="dsa_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show WhoIs Link", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_whois_link');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"dsa_whois_link");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show WWW Link", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_www_link');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"dsa_www_link");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Disable Domain Spinning", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_disable_domain_spinning');
                            $data = array("0"=>"No","1"=>"Yes");
                            echo whmpress_draw_combo($data,$selected,"dsa_disable_domain_spinning");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Order Landing Page", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_order_landing_page');
                            $data = array("no"=>"No of years and Additional domains first","yes"=>"Go direct to domain settings");
                            echo whmpress_draw_combo($data,$selected,"dsa_order_landing_page");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Price", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_show_price');
                            $data = array("1"=>"Yes","0"=>"No");
                            echo whmpress_draw_combo($data,$selected,"dsa_show_price");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Years", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_show_years');
                            $data = array("1"=>"Yes","0"=>"No");
                            echo whmpress_draw_combo($data,$selected,"dsa_show_years");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Search in Extensions", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsa_search_extensions');
                            $data = array("1"=>"Only Listed in WHMCS","0"=>"All");
                            echo whmpress_draw_combo($data,$selected,"dsa_search_extensions");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainSearchAjaxResult" class="tab">
                <div class="error">
                    <p><b>Warning:</b> This short-code is listed only for compatibility with previous versions. It will be removed in v.3.0. Please use domain_search_ajax  on both search box and search results pages.</p>
                </div>
                <h3>Domain Search Ajax Result</h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Show WhoIs Link", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsar_whois_link');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"dsar_whois_link");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show WWW Link", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsar_www_link');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"dsar_www_link");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Price", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsar_show_price');
                            $data = array("1"=>"Yes","0"=>"No");
                            echo whmpress_draw_combo($data,$selected,"dsar_show_price");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Years", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsar_show_years');
                            $data = array("1"=>"Yes","0"=>"No");
                            echo whmpress_draw_combo($data,$selected,"dsar_show_years");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainSearchBulk" class="tab">
                <h3>Domain Search Bulk</h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Placeholder", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsb_placeholder');
                            ?>
                            <input name="dsb_placeholder" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button Text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsb_button_text');
                            ?>
                            <input name="dsb_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-DomainWhoIS" class="tab">
                <h3>Domain WhoIS</h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Placeholder", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dw_placeholder');
                            ?>
                            <input name="dw_placeholder" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Button Text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dw_button_text');
                            ?>
                            <input name="dw_button_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-OrderLink" class="tab">
                <h3>Order Link</h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Link Text", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('ol_link_text');
                            ?>
                            <input name="ol_link_text" value="<?php echo esc_attr( $selected ); ?>">
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-Description" class="tab">
                <h3>WMMpress Description</h3>
                <table class="form-table">
                    <tr valign="top">
                        <th scope="row"><?php _e("Show As", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('dsc_description');
                            $data = array("ul"=>"Unordered List","ol"=>"Ordered List",""=>"Simple");
                            echo whmpress_draw_combo($data,$selected,"dsc_description");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-PriceMatrix" class="tab">
                <h3>Price Matrix</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Decimals", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_decimals');
                            $data = array(); for($x=1; $x<=4; $x++) $data[] = $x;
                            echo whmpress_draw_combo($data,$selected,"pm_decimals");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Hidden", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_show_hidden');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"pm_show_hidden");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Replace Zero With", "whmpress") ?></th>
                        <td>
                            <input name="pm_replace_zero" value="<?php echo esc_attr( whmpress_get_option('pm_replace_zero' ) ); ?>">
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Replace Empty With", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_replace_empty');
                            ?>
                            <input name="pm_replace_empty" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                    
                    <tr valign="top">
                        <th scope="row"><?php _e("Hide Search", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_hide_search');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"pm_hide_search");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Search Label", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_search_label');
                            ?>
                            <input name="pm_search_label" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Search Placeholder", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pm_search_placeholder');
                            ?>
                            <input name="pm_search_placeholder" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                </table>
            </div>
            
            <div id="tab-PriceMatrixDomain" class="tab">
                <h3>Price Matrix Domain</h3>
                <table class="form-table">
            		<tr valign="top">
                        <th scope="row"><?php _e("Decimals", "whmpress") ?></td>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_decimals');
                            $data = array(); for($x=1; $x<=4; $x++) $data[] = $x;
                            echo whmpress_draw_combo($data,$selected,"pmd_decimals");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Renewel Price", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_show_renewel');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"pmd_show_renewel");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Transfer Price", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_show_transfer');
                            $data = array("Yes","No");
                            echo whmpress_draw_combo($data,$selected,"pmd_show_transfer");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Hide Search", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_hide_search');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"pmd_hide_search");
                            ?>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Search Label", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_search_label');
                            ?>
                            <input name="pmd_search_label" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Search Placeholder", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_search_placeholder');
                            ?>
                            <input name="pmd_search_placeholder" value="<?php echo esc_attr( $selected ); ?>" />
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php _e("Show Disabled Domains", "whmpress") ?></th>
                        <td>
                            <?php
                            $selected = whmpress_get_option('pmd_show_disabled');
                            $data = array("No","Yes");
                            echo whmpress_draw_combo($data,$selected,"pmd_show_disabled");
                            ?>
                        </td>
                    </tr>
                </table>
            </div>
            
            <p class="resetbutton">
    			<a href="#">Reset all settings</a>
    		</p>
            <p class="submitbutton">
    			<input type="submit" class="submit-form button-primary" value="Save Changes" disabled />
    		</p>
        </div>
    </div>
</div>
<div id="currencies">
    <h3 class="whmp-sub-head"><?php _e("Currency settings", "whmpress") ?></h3>
    
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row"><?php _e("Override WHMCS default currency with", "whmpress") ?></td>
            <td><?php $default_curr=whmpress_get_option("whmpress_default_currency"); ?>
                <select name="whmpress_default_currency">
                    <?php
                    foreach($currencies as $currency): ?>
                    <option <?php echo ($default_curr==$currency["id"])?"selected='selected'":"" ?> value="<?php echo $currency["id"] ?>"><?php echo $currency["code"] ?></option>
                    <?php endforeach; ?>
                </select>
            </td>
        </tr>
    </table>
<style>
table#country_table thead td {
    font-weight:bold;
    font-size:16px;
    padding:5px;
}
</style>
    <h3 class="whmp-sub-head"><?php _e("Country specific currency", "whmpress") ?></h3>
    <table id="country_table">
        <thead>
        <tr>
            <td colspan="2"><button onclick="AddTR()" type="button" class="button button-primary">Add Country</button></td>
        </tr>
        <tr>
            <td>Country</td>
            <td>Currency</td>
        </tr>
        </thead>
        <tbody>
        <?php
        $whmp_countries_currencies = get_option("whmp_countries_currencies");
        if (!is_array($whmp_countries_currencies)) $whmp_countries_currencies = array();
        if (isset($whmp_countries_currencies["country"]))
        for($x=0; $x<count($whmp_countries_currencies["country"]); $x++): ?>
        <tr>
            <td>
                <select name="whmp_countries_currencies[country][]">
                <option value="">-- Select Country --</option>
                <?php foreach($countries as $country): $S = $whmp_countries_currencies["country"][$x]==$country->country_code?"selected=selected":""; ?>
                <option <?php echo $S ?> value="<?php echo $country->country_code ?>"><?php echo $country->country_name ?></option>
                <?php endforeach ?>
                </select>
            </td>
            <td>
                <select name="whmp_countries_currencies[currency][]">
                <option value="">-- Currency --</option>
                <?php foreach($currencies as $currency): $S = $whmp_countries_currencies["currency"][$x]==$currency["id"]?"selected=selected":""; ?>
                <option <?php echo $S ?> value="<?php echo $currency["id"] ?>"><?php echo $currency["code"] ?></option>
                <?php endforeach ?>
                </select>
                [<a title="Remove this country" href="javascript:;" onclick="Remove(this)">X</a>]
            </td>
        </tr>
        <?php endfor; ?>
        </tbody>
        <tfoot>
        
        <?php
            if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' ))
                $disabled="disabled=disabled";
            else
                $disabled=""; ?>
        <tr>
            <td></td>
            <?php if ($disabled==""): ?>
            <td colspan="3"><?php submit_button(); ?></td>
            <?php else: ?>
            <td colspan="3"><input disabled="disabled" type="button" name="submit" id="submit" class="button button-primary" value="<?php _e("Save Changes", "whmpress") ?>"  /></td>
            <?php endif; ?>
        </tr>
        </tfoot>
    </table>
</div>
<div id="3rdparty">
    <h3 class="whmp-sub-head"><?php _e("URL override for compatibility with third party tools (WHMCS Bridge)", "whmpress") ?></h3>
    
    <?php if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
        $disabled="disabled=disabled"; ?>
        <div style="border: 2px solid #FCBD28;padding:10px;background:#FFFFFF;font-weight:bold">
        <?php _e("WHMCS Client Area Addon is Active. If you want to use a third party plugin for this purpose (WHMCS-bridge) please deactivate the WHMCS Client Area Addon by WHMpress", "whmpress") ?></div>
    <?php } else {
        $disabled="";
    } ?>
    
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row"><?php _e("Client Area URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="client_area_url" value="<?php echo esc_attr( whmpress_get_option('client_area_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Announcements URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="announcements_url" value="<?php echo esc_attr( whmpress_get_option('announcements_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Submit Ticket URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="submit_ticket_url" value="<?php echo esc_attr( whmpress_get_option('submit_ticket_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Downloads page URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="downloads_url" value="<?php echo esc_attr( whmpress_get_option('downloads_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Support Tickets URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="support_tickets_url" value="<?php echo esc_attr( whmpress_get_option('support_tickets_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Knowledgebase URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="knowledgebase_url" value="<?php echo esc_attr( whmpress_get_option('knowledgebase_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Affiliates URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="affiliates_url" value="<?php echo esc_attr( whmpress_get_option('affiliates_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Order URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="order_url" value="<?php echo esc_attr( whmpress_get_option('order_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Pre-sales Contact URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="pre_sales_contact_url" value="<?php echo esc_attr( whmpress_get_option('pre_sales_contact_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Domain Checker URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="domain_checker_url" value="<?php echo esc_attr( whmpress_get_option('domain_checker_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Server Status URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="server_status_url" value="<?php echo esc_attr( whmpress_get_option('server_status_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("Network Issues URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="network_issues_url" value="<?php echo esc_attr( whmpress_get_option('network_issues_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("WHMCS Login URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="whmcs_login_url" value="<?php echo esc_attr( whmpress_get_option('whmcs_login_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("WHMCS Register URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="whmcs_register_url" value="<?php echo esc_attr( whmpress_get_option('whmcs_register_url') ); ?>" />
            </td>
        </tr>
        
        <tr valign="top">
            <td scope="row"><?php _e("WHMCS Forget Password URL", "whmpress") ?></td>
            <td>
                <input <?php echo $disabled ?> type="url" style="width:100%;" name="whmcs_forget_password_url" value="<?php echo esc_attr( whmpress_get_option('whmcs_forget_password_url') ); ?>" />
            </td>
        </tr>
        
        <tr>
            <td></td>
            <?php if ($disabled==""): ?>
            <td colspan="3"><?php submit_button(); ?></td>
            <?php else: ?>
            <td colspan="3"><input disabled="disabled" type="button" name="submit" id="submit" class="button button-primary" value="<?php _e("Save Changes", "whmpress") ?>"  /></td>
            <?php endif; ?>
        </tr>
    </table>
</div>
<div id="advanced">
    <h3 class="whmp-sub-head">Advanced Settings</h3>
    <table class="form-table">
        <tr valign="top">
            <td style="width:30%;" scope="row"><?php _e("Override WHMCS URL", "whmpress") ?></td>
            <td>
                <input type="url" style="width:100%;" name="overwrite_whmcs_url" value="<?php echo esc_attr( whmpress_get_option('overwrite_whmcs_url') ); ?>" />
            </td>
        </tr>
        
        <tr>
            <td></td>
            <td colspan="3"><?php submit_button(); ?></td>
        </tr>
    </table>
</div>
</form>
<div id="registration">
    <h3 class="whmp-sub-head"><?php _e("Registration", "whmpress") ?></h3>
    <?php if ( WHMpress::verified_purchase() ): ?>
    <table class="form-table">
    <tr>
        <td><?php _e("Your purchase of WHMpress is registered") ?></td>
        <td style="text-align: right;"><button type="button" class="button button-red" onclick="UnVerify();">Un-Register WHMpress</button></td>
    </tr>
    </table>
    <?php else: ?>
    <form onsubmit="return Verify();" name="verify_form" id="verify_form">
        <table style="width:100%">
            <tr>
                <td colspan="3"><?php _e("Email required for providing support for this product", "whmpress") ?></td>
            </tr>
            <tr>
                <td><input required="required" style="width:100%;" type="email" id="femail" name="email" placeholder="<?php _e("Email address","whmpress") ?>" value="<?php echo get_option("admin_email") ?>" /></td>
                <td><input required="required" style="width:100%;" type="text" id="fpurchase_code" name="purchase_code" placeholder="<?php _e("Purchase Code", "whmpress") ?>" /></td>
                <td><button type="button" onclick="Verify();" style="width:100%;" class="button button-primary"><?php _e("Verify","whmpress") ?></button></td>
            </tr>
        </table>
    </form>
    <?php endif; ?>
</div>
<span id="settingsloaded"></span>
<script>
/*jQuery(function(){
    var editor = CodeMirror.fromTextArea(document.getElementById("whmp_custom_css"), {
        lineNumbers: true,
        mode: 'css'
      });
      editor.setSize('900','500');
});*/
</script>
<?php endif; ?>
</div>

<script type="text/javascript">
jQuery(document).ready(function () {
    jQuery('ul.tabs').each(function(){
    // For each set of tabs, we want to keep track of
    // which tab is active and it's associated content
    var $active, $content, $links = jQuery(this).find('a');

    // If the location.hash matches one of the links, use that as the active tab.
    // If no match is found, use the first link as the initial active tab.
    $active = jQuery($links.filter('[href="'+location.hash+'"]')[0] || $links[0]);
    $active.addClass('active');

    $content = jQuery($active[0].hash);

    // Hide the remaining content
    $links.not($active).each(function () {
        jQuery(this.hash).hide();
    });

    // Bind the click event handler
    jQuery(this).on('click', 'a', function(e){
        // Make the old tab inactive.
        $active.removeClass('active');

        $content.hide();
    
        // Update the variables with the new link and content
        $active = jQuery(this);
        $content = jQuery(this.hash);
    
        // Make the tab active.
        $active.addClass('active');
        $content.show();
        
        // Prevent the anchor's default click action
        e.preventDefault();
    });
  });
});
function UnVerify() {
    if (!confirm("Are you sure you want to unverify your purchase?")) return;
    jQuery(".full_page_loader").show();
    jQuery.post(ajaxurl, {'action':'whmp_unverify'}, function(response){
        if (response=="OK") {
            window.location.reload();
        } else {
            alert (response);
        }
        jQuery(".full_page_loader").hide();
    });
    return false;
}
function Verify() {
    jQuery(".full_page_loader").show();
    var data = "purchase_code=" + jQuery("#fpurchase_code").val() + "&email=" + jQuery("#femail").val();
    data += "&action=whmp_verify";
    jQuery.post(ajaxurl, data, function(response){
        if (response=="OK") {
            window.location.reload();
        } else {
            jQuery(".full_page_loader").hide();
            alert (response);
        }
    });
    return false;
}
function AddTR() {
    //alert ( jQuery("#new_tr").html() );
    jQuery("#country_table tbody").append( "<?php echo $newTR ?>" );
}
function Remove(tthis) {
    jQuery(tthis).parent().parent().remove();
}
</script>