<?php
if (defined('ICL_LANGUAGE_CODE')) $the_lang = ICL_LANGUAGE_CODE;
else $the_lang = get_locale();

// All shortcodes and their functions are defined in array to recognise
$whmp_shortcodes_list = array(
    "whmpress_price" => "whmpress_price_function",
    "whmpress_domain_price" => "whmpress_domain_price_function",
    "whmpress_price_table" => "whmpress_price_table_function",
    "whmpress_price_matrix" => "whmpress_price_table_function",
    "whmpress_price_table_domain" => "whmpress_price_table_domain_function",
    "whmpress_price_matrix_domain" => "whmpress_price_table_domain_function",
    "whmpress_order_combo" => "whmpress_order_combo_function",
    "whmpress_order_button" => "whmpress_order_button_function",
    "whmpress_order_link" => "whmpress_order_link_function",
    "whmpress_order_url" => "whmpress_order_url_function",
    "whmpress_currency" => "whmpress_currency_function",
    "whmpress_currency_combo" => "whmpress_currency_combo_function",
    "whmpress_currency_combo_fancy" => "whmpress_currency_combo_fancy_function",
    "whmpress_name" => "whmpress_name_function",
    "whmpress_description" => "whmpress_description_function",
    "whmpress_price_box" => "whmpress_price_box_function",
    "whmpress_pricing_table" => "whmpress_pricing_table_function",
    "whmpress_domain_search" => "whmpress_domain_search_function",
    "whmpress_domain_search_ajax" => "whmpress_domain_search_ajax_function",
    "whmpress_domain_search_ajax_results" => "whmpress_domain_search_ajax_results_function",
    "whmpress_domain_search_extended_ajax" => "whmpress_domain_search_extended_ajax_function",
    "whmpress_domain_search_extended_ajax_results" => "whmpress_domain_search_extended_ajax_results_function",
    "whmpress_domain_search_bulk" => "whmpress_domain_search_bulk_function",
    "whmpress_domain_whois" => "whmpress_whois_function",
    
    "whmpress_login_form" => "whmpress_login_form_function",
    "whmpress_url" => "whmpress_url_function",
    "whmpress_announcements" => "whmpress_announcements_function",
    
    #"whmpress_geek" => "whmpress_geek_function",
    #"whmpress_cyearly" => "whmp_shortcode_yearly",
    #"whmpress_cmonthly" => "whmp_shortcode_cmonthly",
);


// Do not use these shortcodes in VC integration and text editor.
$donot_use = array(
    "whmpress_price_table","whmpress_price_table_domain","whmpress_currency_combo_fancy"
);

// Adding all shortcodes mentioned in array above
foreach($whmp_shortcodes_list as $shortcode=>$func) {
    add_shortcode($shortcode, $func);
}

function whmpress_announcements_function($atts, $content=null) {
    extract( shortcode_atts( array(
        'count' => '3',
        'words' => '25',
	), $atts ) );
    
    if (!is_numeric($count)) $count = "3";
    if ($count<1) $count = "3";
    
    if (!is_numeric($words)) $words = "25";
    if ($words<1) $words = "25";
    
    global $wpdb;
    $table_name = $wpdb->prefix."whmpress_announcements";
    $Q = "SELECT * FROM `{$table_name}` WHERE (published='1' OR published='on') ORDER BY date DESC LIMIT 0,{$count}";
    $rows = $wpdb->get_results($Q);
    
    if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
        global $WHMPress_Client_Area;
        if (empty($WHMPress_Client_Area)) $WHMPress_Client_Area = new WHMPress_Client_Area;
        $blog_url = get_option("client_area_page_url");
        if (is_numeric($blog_url)) $blog_url = get_page_link($blog_url);
        if ($WHMPress_Client_Area->is_permalink()) {
            $url = rtrim($blog_url,"/")."/whmpca/announcements/id/{{id}}/";
        } else {
            $url = $blog_url."?whmpca=announcements&id={{id}}";
        }
    } else {
        $url = rtrim(get_option("whmcs_url"),"/")."/announcements.php?id={{id}}";
    }
    
    $return_string = "";
    foreach($rows as $row) {
        $row->announcement = explode(" ", $row->announcement);
        array_splice($row->announcement, $words);
        $row->announcement = implode(" ", $row->announcement);
        
        $url = str_replace("{{id}}", $row->id, $url);
        
        $return_string .= "<div class=\"whmpress_announcements\">
          <span class=\"announcement-date\">".mysql2date(get_option('date_format'), $row->date)." - </span>
          <a class=\"announcement-id\" href=\"{$url}\"><b>{$row->title}</b></a>
          <p class=\"announcement-summary\">" . $row->announcement ."</p>
        </div>\n";
    }
    
    return $return_string;
}

function whmpress_domain_price_function($atts, $content = null) {
    $OutputString = include (WHMP_PLUGIN_DIR."/includes/shortcodes/whmpress_domain_price.php");
    return $OutputString;
}

function whmpress_url_function($atts, $content = null) {
    extract( shortcode_atts( array(
        'type' => 'client_area'
	), $atts ) );
    
    
    if ($type=="") $type="client_area";
    $html = include (WHMP_PLUGIN_DIR."/includes/shortcodes/whmpress_url.php");
    return $html;
}

function whmpress_login_form_function($atts, $content = null) {
/**
 * Return WHMCS registration form
 * 
 * List of parameters
 * html_class = HTML class for container
 * html_id = HTML id for container
 * button_class = HTML class for button
 * button_text = Button text
 */
 
    extract( shortcode_atts( array(
        'html_template' => '',
        'image' => '', 
		'button_class' => '',
        'button_text' => whmpress_get_option("ob_button_text"),
		'html_id' => '',
        'html_class' => 'whmpress whmpress_login_form',
	), $atts ) );
 
 # Checking parameters
    #$button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    #$html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="") $html_class = "whmpress whmpress_login_form";
    #$html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    #$button_text = !empty($atts["button_text"])?$atts["button_text"]:"Login";
    
    # Generating output form
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_login_form");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "action_url" => WHMPress::get_whmcs_url("loginurl"),
            "username_field" => "<label>Username:</lable> <input type='text' name='username' >",
            "password_field" => "<label>Password:</lable> <input type='password' name='password' >",
            "button" => "<input type='submit' value='Login'>",
            "button_text" => $button_text,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_login_form");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $str = '<form method="post" action="'.WHMPress::get_whmcs_url("loginurl").'">'."\n";
        $str .= '<div><label>'.__("Email address",'whmpress').'</label><input placeholder="'.__("Email address",'whmpress').'" type="text" name="username" /></div>'."\n";
        $str .= '<div><label>'.__("Password",'whmpress').'</label><input placeholder="'.__("Password",'whmpress').'" type="password" name="password" /></div>'."\n";
        $str .= '<button class="search_btn '.$button_class.'">'.__($button_text, "whmpress").'</button>'."\n";
        $str .= "</form>\n";

        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}

function whmpress_whois_function($atts) {
/**
 * Displays a form for getting whois info of multiple line provided domains
 * 
 * List of parameters
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 * result_text = HTML class for output result
 */

    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'text_class' => '',
        'button_class' => '',
        'html_class' => 'whmpress whmpress_domain_whois',
        'html_id' => '',
        'placeholder' => whmpress_get_option('dw_placeholder'),
        'button_text' => whmpress_get_option('dw_button_text'), //'Get Whois',
        'result_text_class' => ''
	), $atts ) );
    
    # Generating output result
    if (isset($_POST["whois_domain"])) {
        include_once (WHMP_PLUGIN_DIR . "/includes/whois.class.php");
        $whois = new Whois;
        
        $tld = strstr($_POST["whois_domain"],'.');
        
        $result = "<div class='whmpress_whois_results'><pre class='$result_text_class'>".$whois->whoislookup($_POST["whois_domain"],$tld,true)."</pre></div>";
    } else {
        $result = "<i>No domain selected</i>";
    }
    
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_whois");
    
    if ( is_file($html_template) ) {
        $whois_domain = isset($_POST["whois_domain"])?$_POST["whois_domain"]:"";
        $vars = array(
            "search_text_box" => '<input required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" name="whois_domain" value="'.$whois_domain.'">',
            "search_button" => '<button class="search_btn '.$button_class.'">'.__($button_text,"whmpress").'</button>',
            "whois_output" => $result
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_whois");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
                
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $str = '<form method="post">'."\n";
        $whois_domain = isset($_POST["whois_domain"])?$_POST["whois_domain"]:"";
        $str .= '<input required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" name="whois_domain" value="'.$whois_domain.'">'."\n";
        $str .= '<button class="search_btn '.$button_class.'">'.$button_text.'</button>'."\n";
        $str .= "</form>\n";

        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . $result . "</div>";
    }
}

function whmpress_domain_search_bulk_function($atts) {
/**
 * Displays a form for getting whois info of multiple line provided domains
 * 
 * List of parameters
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'text_class' => '',
        'button_class' => '',
        'html_class' => 'whmpress whmpress_domain_search_bulk',
        'html_id' => '',
        'placeholder' => whmpress_get_option('dsb_placeholder'),
        'button_text' => whmpress_get_option('dsb_button_text'),
	), $atts ) );
    global $wpdb;
    $button_text = __($button_text, "whmpress");
    # Generating output result
    $HTML = "";
    //$HTML = print_r($_POST, true);
    if (isset($_POST["search_bulk_domain"])) {
        $HTML .= "<div class='result-div'>";
        
        $extention_selection = isset($_POST["extention_selection"])?$_POST["extention_selection"]:"0";
        
        if ($extention_selection=="1") {
            $domains_set = isset($_POST["search_bulk_domain"])?$_POST["search_bulk_domain"]:"";
            $domains_set = explode("\n",$domains_set);
            if (!isset($_POST["extension"])) {
                $extension = array(".com");
                $_POST["extension"] = array(".com");
            }
            else $extension = $_POST["extension"];
            //$HTML .= print_r($_POST, true);
            $domains = array();
            foreach($extension as $ext) {
                foreach($domains_set as $domain) {
                    $domains[] = $domain.$ext;
                }
            }
        } else {
            $domains = isset($_POST["search_bulk_domain"])?$_POST["search_bulk_domain"]:"";
            $domains = explode("\n",$domains);
        }
        
        include_once (WHMP_PLUGIN_DIR . "/includes/whois.class.php");
        $whois = new Whois;
        
        global $wpdb;
        
        foreach($domains as $domain) {
            if (trim($domain)<>""):
            $domain = ltrim($domain, '//');
            if (substr(strtolower($domain), 0, 7) == "http://") $domain = substr($domain, 7);
            if (substr(strtolower($domain), 0, 8) == "https://") $domain = substr($domain, 8);
            if (strtolower(substr($domain,0,4))=="www.") $domain["host"] = substr($domain,4);
            if (strtolower(substr($domain,0,3))=="ww.") $domain["host"] = substr($domain,3);
            
            $ext = whmp_get_domain_extension($domain);
            $onlydomain = str_replace("." . $ext, "", $domain);
                        
            if ($ext == $onlydomain) {
                $ext = "com";
                $onlydomain .= ".com";
            }
            $result = $whois->whoislookup($domain, $ext);
                    
            if ($result) {
                $ext = ".".ltrim($ext,".");
                $Dom = $domain;
                $Message = get_option('ongoing_domain_available_message',__("[domain-name] is available", "whmpress") );
                if ($Message=="") $Message = __("[domain-name] is available", 'whmpress');
                $Message = str_replace("[domain-name]", $Dom, $Message);
                
                $Q = "SELECT d.id, d.extension 'tld', t.type, c.code, c.suffix, c.prefix, t.msetupfee, t.qsetupfee
                FROM `".whmp_get_domain_pricing_table_name()."` AS d
                INNER JOIN `".whmp_get_pricing_table_name()."` AS t ON t.relid = d.id
                INNER JOIN `".whmp_get_currencies_table_name()."` AS c ON c.id = t.currency
                WHERE t.type
                IN (
                'domainregister'
                ) AND d.extension IN ('{$ext}')
                AND c.code='".whmp_get_currency_code(whmp_get_currency())."' 
                ORDER BY d.id ASC 
                LIMIT 0 , 30";
                $price = $wpdb->get_row($Q,ARRAY_A);
                
                $register_text = get_option('register_domain_button_text',"Select");
                if ($register_text=="") $register_text="Select";
                if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
                    global $WHMPress_Client_Area;
                    if (empty($WHMPress_Client_Area)) $WHMPress_Client_Area = new WHMPress_Client_Area;
                    if ($WHMPress_Client_Area->is_permalink())
                        $_url = WHMPress::get_whmcs_url("order")."/a/add/domain/register/sld/{$onlydomain}/tld/{$ext}/";
                    else
                        $_url = WHMPress::get_whmcs_url("order")."a=add&domain=register&sld={$onlydomain}&tld={$ext}";
                } else
                    $_url = WHMPress::get_whmcs_url("order")."a=add&domain=register&sld={$onlydomain}&tld={$ext}";
                if (!empty($price["msetupfee"]))
                    $button = "<a href='$_url' class='buy-button'>$register_text</a>";
                else $button = "";
                
                $pricef = ($price["msetupfee"]>"0"?$price["msetupfee"]:$price["qsetupfee"]);
                if ((get_option('default_currency_symbol',"prefix")=="code" || get_option('default_currency_symbol',"prefix")=="prefix") && isset($price[get_option('default_currency_symbol',"prefix")])) {
                    $pricef = $price[ get_option('default_currency_symbol',"prefix")].$pricef;
                } else if (get_option('default_currency_symbol')=="suffix" && isset($price[get_option('default_currency_symbol')])) {
                    $pricef = $pricef.$price[get_option('default_currency_symbol')];
                }
                
                if ($price["msetupfee"]>0)
                    $year = "(1 ".__("Year", "whmpress").")";
                else if ($price["qsetupfee"]>0)
                    $year = "(2 ".__("Years", "whmpress").")";
                else
                    $year = "";
                
                $HTML .= "
                <div class='found-div'>
                    <div class=\"domain-name\">$Message</div>
                    <div class=\"rate\">$pricef</div>
                    <div class=\"year\">$year</div>
                    <div class=\"select-box\">
                        $button
                    </div>
                    <div style=\"clear:both\"></div>
                </div>\n";
                    
                /*$HTML .= "
                <div class='found-div'><span><i class='fa fa-check'></i> $Message</span>
                $button
                <div style='clear:both'></div>
                </div>\n";*/
            } else {
                /*$Dom = $domain;
                $Message = get_option('ongoing_domain_not_available_message',"[domain-name] is registered");
                $Message = str_replace("[domain-name]", $Dom, $Message);
                $HTML .= "<div class='not-found-div'>
                    <span><i class='fa fa-warning'></i> $Message<span></div>\n";*/
                    
                $Dom = $domain;
                #if (isset($_POST["www_link"]) && strtolower($_POST["www_link"])=="yes") {
                    $www_link = "<a class=\"www-button\" href='http://{$Dom}' target='_blank'>".__("WWW","whmpress")."</a>";
                #} else {
                    #$www_link = "";
                #}
                
                #if (isset($_POST["whois_link"]) && strtolower($_POST["whois_link"])=="yes") {
                    //$whois_link = "<a class='whois-button' href='javascript:;' onclick='window.open(\"".WHMP_PLUGIN_URL."/whois.php?domain={$Dom}\",\"whmpwin\",\"width=600,height=600,toolbar=no,location=no,directories=no,status=no,menubar=no,resizable=0\")'>WHOIS</a>";
                    $whois_link = "<a class='whois-button' href='".WHMP_PLUGIN_URL."/whois.php?domain={$Dom}' target='_blank'>".__("WHOIS","whmpress")."</a>";
                #} else {
                    #$whois_link = "";
                #}
                
                $Message = get_option('ongoing_domain_not_available_message',"[domain-name] is registered");
                if ($Message=="") $Message = "[domain-name] is registered";
                $Message = str_replace("[domain-name]", "<span>".$Dom."</span>", $Message);
                $HTML .= "<div class='not-found-div'>";
                $HTML .= '<div class="domain-name">'.$Message.'</div>';
                $HTML .= "
                <div class=\"rate\"></div>
                <div class=\"year\"></div>
                <div class=\"select-box\">
                    $www_link
                    $whois_link
                </div>";
                $HTML .= "<div style=\"clear:both\"></div>
                </div>\n";
            }
            endif;
        }
        $HTML .= "</div>";
    }
    
    $extensions = $wpdb->get_results("SELECT `extension` FROM `".whmp_get_domain_pricing_table_name()."` ORDER BY `order`");
    $exts = ""; $smarty_extensions = array();
    foreach($extensions as $ext) {
        if (isset($_POST["extension"]) && is_array($_POST["extension"]))
            $checked = in_array($ext->extension,$_POST["extension"])?"checked=checked":"";
        else
            $checked = "";
        $exts .= "<div class=\"\">
              <input type=\"checkbox\" value=\"{$ext->extension}\" id=\"{$ext->extension}\" name=\"extension[]\" $checked />
              <label for=\"{$ext->extension}\">{$ext->extension}</label>
            </div>\n";
        $smarty_extensions[] = $ext->extension;
    }
    
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search_bulk");
    
    if ( is_file($html_template) ) {
        $search_bulk_domain = isset($_POST["search_bulk_domain"])?$_POST["search_bulk_domain"]:"";
        $vars = array(
            "search_textarea" => '<textarea required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" name="search_bulk_domain">'.$search_bulk_domain.'</textarea>',
            "search_button" => '<button class="search_btn '.$button_class.'">'.$button_text.'</button>',
            "search_results" => $HTML,
            "button_text" => $button_text,
            "data_extensions" => $smarty_extensions,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search_bulk");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        //$str = '<form method="post">'."\n";
        $search_bulk_domain = isset($_POST["search_bulk_domain"])?$_POST["search_bulk_domain"]:"";
        //$str .= '<textarea required="required" class="'.$text_class.'" placeholder="'.$placeholder.'" name="search_bulk_domain">'.$search_bulk_domain.'</textarea>'."\n";

        if (isset($_POST["extention_selection"]) && $_POST["extention_selection"]=="1")
            $display = "";
        else
            $display = "none";
        if (!isset($_POST["extention_selection"]) || (isset($_POST["extention_selection"]) && $_POST["extention_selection"]=="0") )
            $checked1 = "checked";
        else
            $checked1 = "";
        
        if (isset($_POST["extention_selection"]) && $_POST["extention_selection"]=="1")
            $checked2 = "checked";
        else
            $checked2 = "";

$ientered = __("I entered fully qualified names","whmpress");
$sthext = __("Search these extentions", "whmpress");
$placeholder = __($placeholder,"whmpress");
$str =<<<EOT
    <script> jQuery(document).ready(function(){ jQuery('input:radio[name="extention_selection"]').change(function(){ if(jQuery(this).val() == '0'){ jQuery('.extentions').css('display','none'); } else { jQuery('.extentions').css('display', 'block'); } }); }); </script>
    <div>
    <form method="post">
        <div class="bulk-domains">
            <textarea required="required" class="$text_class" placeholder="$placeholder" name="search_bulk_domain">$search_bulk_domain</textarea>
        </div>
        <div class="bulk-options">
            <div class="extention-selection">
                <label><input type="radio" name="extention_selection" value="0" $checked1> $ientered</label><br>
                <label><input type="radio" name="extention_selection" value="1" $checked2> $sthext</label>
            </div>
            <div class="extentions" style="display:$display">
                $exts
            </div>
            <div style="clear:both"></div>
            <div class="search-button">
                <button class="search_btn $button_class">$button_text</button>
            </div>
        </div>
    </form>
    </div>
    <div style="clear:both"></div>
EOT;
        
        # Returning output form
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<!-- WHMPress -->\n<div $CLASS $ID>" . $str . $HTML . "</div><!-- End WHMPress -->";
    }
}


function whmpress_domain_search_extended_ajax_function($atts) {
/**
 * Displays a form for getting whois info of domains
 * 
 * List of parameters
 * action = Action url for form. Form will submit on this url
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'text_class' => '',
        'button_class' => '',
        'action' => '',
        'html_class' => 'whmpress whmpress_domain_search_ajax',
        'html_id' => '',
        'placeholder' => 'Search',
        'button_text' => 'Search',
        "whois_link" => "yes",
        "www_link" => "yes",
        "disable_domain_spinning" => whmpress_get_option("dsa_disable_domain_spinning"),
        "order_landing_page" => whmpress_get_option("dsa_order_landing_page"),
        "show_price" => whmpress_get_option("dsa_show_price"),
        "show_years" => whmpress_get_option("dsa_show_years"),
	), $atts ) );
    
    # Generating output form
    $WHMPress = new WHMPress;
    
    if (strtoupper($order_landing_page)=="YES" || $order_landing_page=="1") $order_landing_page = "1"; else $order_landing_page = "0";
    if (strtoupper($disable_domain_spinning)=="YES" || $disable_domain_spinning=="1") $disable_domain_spinning = "1"; else $disable_domain_spinning = "0";
    if (strtoupper($show_price)=="NO" || $show_price=="0") $show_price = "0"; else $show_price = "1";
    if (strtoupper($show_years)=="NO" || $show_years=="0") $show_years = "0"; else $show_years = "1";
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search_extended_ajax");
    
    if ( is_file($html_template) ) {
        $search_domain = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
        $vars = array(
            "search_text_box" => '<input required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" value="'.$search_domain.'" type="search" name="search_domain" />',
            "search_button" => '<button class="search_btn '.$button_class.'">'.__($button_text, "whmpress").'</button>',
            "action" => $action
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search_extended_ajax");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $ajaxID = uniqid("ajaxForm");
        $ACTION = empty($action)?"":"action='$action'";
        $str = "<form $ACTION method='get' id='form{$ajaxID}'";
        if ($action=="") {
            $str .= " onsubmit='return Search{$ajaxID}(this);'";
        }
        $str .= '>'."\n";
        if ($action=="") {
            foreach($_GET as $k=>$v) {
                if ($k<>"search_domain")
                    $str .= "<input type='hidden' name='$k' value=\"$v\" />\n";
            }
        }
        $str .= '<input type="hidden" name="skip_extra" value="0" />';
        $search_domain = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
        $str .= '<input required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" value="'.$search_domain.'" type="search" id="search_box" name="search_domain" />'."\n";
        $str .= '<button class="search_btn '.$button_class.'">'.__($button_text,"whmpress").'</button>'."\n";
        $str .= "<div class='clear:both'></div>";
        $str .= "</form>\n";
        
        $str .= "<script>
            jQuery(function(){
                jQuery.post(WHMPAjax.ajaxurl, {'domain':jQuery('#search_box').val(),'action':'whmpress_action','do':'getDomainData','skip_extra':'0','searchonly':'{$searchonly}','lang':'".$the_lang."'}, function(data){
                    jQuery(\"#search_result_div\").html(data);
                });
                jQuery(document).on('click', \"#load-more-div button\", function () {
                    jQuery(\"#load-more-div\").remove();
                    //jQuery(\"#search_result_div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"icon-spinner fa-spin\"></i></div>');
                    jQuery(\".result-div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"fa fa-spinner fa-spin\"></i></div>');
                    whmp_page++;
                    jQuery.post(WHMPAjax.ajaxurl, {'domain':jQuery('#search_box').val(),'action':'whmpress_action','do':'loadWhoisPage','skip_extra':'0','page':whmp_page,'searchonly':'{$searchonly}','lang':'".$the_lang."'}, function(data){
                        jQuery(\"#waiting_div\").remove();
                        jQuery(\".result-div\").append(data);
                    });
                });
            });
            </script>\n";
        
        if ($action=="") {
            $str .= "<div id='$ajaxID'>";
            $str .= whmpress_domain_search_extended_ajax_results_function(array(
                "searchonly" => "*",
                'html_class' => 'whmpress whmpress_domain_search_ajax_results',
                'html_id' => "{$ajaxID}2",
                'whois_link' => $whois_link,
                "www_link" => $www_link,
                "disable_domain_spinning" => $disable_domain_spinning,
            ));
            $str .= "</div>";
            $str .= "<script>
            function Search{$ajaxID}(form) {
                whmp_page=1;
                jQuery('#{$ajaxID}2').html('<i class=\"fa fa-spinner fa-spin\"></i> Loading .....');
                jQuery.post(WHMPAjax.ajaxurl,{'show_price':'$show_price','show_years':'$show_years','order_landing_page':'$order_landing_page','disable_domain_spinning':'$disable_domain_spinning','domain':jQuery('#form{$ajaxID} input[type=search]').val(),'action':'whmpress_action','do':'getDomainData','www_link':'$www_link','whois_link':'$whois_link','searchonly':'*','skip_extra':'0','page':'1','lang':'".$the_lang."'},function(data){
                    jQuery('#{$ajaxID}2').html(data);
                });
                return false;
            }
            </script>";
        }
        
        # Returning output form
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}


function whmpress_domain_search_ajax_function($atts) {
/**
 * Displays a form for getting whois info of domains
 * 
 * List of parameters
 * action = Action url for form. Form will submit on this url
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 */

    $params = shortcode_atts( array(
        'html_template' => '',
        'image' => '',
        'text_class' => '',
        'button_class' => '',
        'action' => '',
        'html_class' => 'whmpress whmpress_domain_search_ajax',
        'html_id' => '',
        'placeholder' => whmpress_get_option("dsa_placeholder"),  // "Search"
        'button_text' => whmpress_get_option("dsa_button_text"), //'Search',
        "whois_link" => whmpress_get_option("dsa_whois_link"), //"yes",
        "www_link" => whmpress_get_option("dsa_www_link"), //"yes",
        "disable_domain_spinning" => whmpress_get_option("dsa_disable_domain_spinning"), //"0",
        "order_landing_page" => whmpress_get_option("dsa_order_landing_page"), //"0",
        "show_price" => whmpress_get_option("dsa_show_price"),
        "show_years" => whmpress_get_option("dsa_show_years"),
        "search_extensions" => whmpress_get_option("dsa_search_extensions"),
    ), $atts );
    extract( $params );
    
    # Generating output form
    $WHMPress = new WHMPress;
    if ("Go direct to domain settings"==$order_landing_page || strtoupper($order_landing_page)=="YES" || $order_landing_page=="1") $order_landing_page = "1"; else $order_landing_page = "0";
    if (strtoupper($disable_domain_spinning)=="YES" || $disable_domain_spinning=="1") $disable_domain_spinning = "1"; else $disable_domain_spinning = "0";
    if (strtoupper($show_price)=="NO" || $show_price=="0") $show_price = "0"; else $show_price = "1";
    if (strtoupper($show_years)=="NO" || $show_years=="0") $show_years = "0"; else $show_years = "1";
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search_ajax");
    
    if ( is_file($html_template) ) {
        $search_domain = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
        $vars = array(
            "search_text_box" => '<input required="required" class="'.$text_class.'" placeholder="'.$placeholder.'" value="'.$search_domain.'" type="search" name="search_domain" />',
            "search_button" => '<button class="search_btn '.$button_class.'">'.$button_text.'</button>',
            "action" => $action,
            "params" => $params,
            "params_encoded" => json_encode($params),
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search_ajax");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $ajaxID = uniqid("ajaxForm");
        $ACTION = empty($action)?"":"action='$action'";
        $str = "<form $ACTION method='get' id='form{$ajaxID}'";
        if ($action=="") {
            $str .= " onsubmit='return Search{$ajaxID}(this);'";
        }
        $str .= '>'."\n";
        if ($action=="") {
            foreach($_GET as $k=>$v) {
                if ($k<>"search_domain")
                    $str .= "<input type='hidden' name='$k' value=\"$v\" />\n";
            }
        }
        
        $str .= '<input type="hidden" name="skip_extra" value="'.$search_extensions.'" />';
        $search_domain = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
        $str .= '<input type="hidden" name="search_domain" value="'.$search_domain.'" />';
        #$str .= '<input type="hidden" name="order_landing_page" value="'.$order_landing_page.'" />';
        #$str .= '<input type="hidden" name="show_price" value="'.$show_price.'" />';
        #$str .= '<input type="hidden" name="show_years" value="'.$show_years.'" />';
        $str .= '<input required="required" class="'.$text_class.'" placeholder="'.__($placeholder,"whmpress").'" value="'.$search_domain.'" type="search" id="search_box" name="search_domain" />'."\n";
        $str .= '<button class="search_btn '.$button_class.'">'.__($button_text,"whmpress").'</button>'."\n";
        $str .= "<div class='clear:both'></div>";
        $str .= "</form>\n";
        $the_lang = "";
        if ($action=="") {
            $str .= "<div id='$ajaxID'>";
            $str .= whmpress_domain_search_ajax_results_function(array(
                "searchonly" => "*",
                'html_class' => 'whmpress whmpress_domain_search_ajax_results',
                'html_id' => "{$ajaxID}2",
                'whois_link' => $whois_link,
                "www_link" => $www_link,
                "disable_domain_spinning" => $disable_domain_spinning,
                "order_landing_page" => $order_landing_page,
                "show_price" => $show_price,
                "show_years" => $show_years,
                "search_extensions" => $search_extensions,
            ));
            $str .= "</div>";
            $str .= "<script>
            function Search{$ajaxID}(form) {
                whmp_page=1;
                jQuery('#{$ajaxID}2').html('<i class=\"fa fa-spinner fa-spin\"></i> Loading .....');
                jQuery.post(WHMPAjax.ajaxurl,{'params':".json_encode($params).",'show_price':'$show_price','show_years':'$show_years','order_landing_page':'$order_landing_page','disable_domain_spinning':'$disable_domain_spinning','domain':jQuery('#form{$ajaxID} input[type=search]').val(),'action':'whmpress_action','do':'getDomainData','www_link':'$www_link','whois_link':'$whois_link','searchonly':'*','skip_extra':'$search_extensions','page':'1','lang':'".$the_lang."'},function(data){
                    jQuery('#{$ajaxID}2').html(data);
                });
                return false;
            }
            </script>";
        }
        
        # Returning output form
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}

function whmpress_domain_search_extended_ajax_results_function($atts) {
/**
 * Displays whois search result submitted by whmpress_domain_search_extended_ajax form
 * 
 * List of parameters
 * searchonly = * for all domain or get result only for specific extensions comma seperated
 * html_class = HTML class for wrapper
 */

    $params = shortcode_atts( array(
        'html_template' => '',
        'images' => '',
        'searchonly' => '*',
        'html_class' => 'whmpress whmpress_domain_search_ajax_results',
        'html_id' => '',
    ), $atts );
    extract( $params );
    
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search_extended_ajax_results");
    
    # Instructions: creative a div with ID search_result_div in HTML template file
    if ( is_file($html_template) ) {
        $vars = array(
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search_extended_ajax_results");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        
        if (isset($_GET["search_domain"])) {
            $str = '<div id="search_result_div">'."\n";
            $str .= '<div style="font-size:30px;text-align: center;">'."\n";
            $str .= '<i class="fa fa-spinner fa-spin"></i>'."\n";
            $str .= "</div>\n";
            $str .= "</div>\n";
            
            if (isset($_GET["ext"])) $_GET["search_domain"] .= $_GET["ext"];
            
            $str .= "<script>
            jQuery(function(){
                jQuery.post(WHMPAjax.ajaxurl, {'domain':'{$_GET["search_domain"]}','action':'whmpress_action','do':'getDomainData','skip_extra':'$search_extensions','searchonly':'{$searchonly}','lang':'".$the_lang."'}, function(data){
                    jQuery(\"#search_result_div\").html(data);
                });
                jQuery(document).on('click', \"#load-more-div button\", function () {
                    jQuery(\"#load-more-div\").remove();
                    //jQuery(\"#search_result_div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"icon-spinner fa-spin\"></i></div>');
                    jQuery(\".result-div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"fa fa-spinner fa-spin\"></i></div>');
                    whmp_page++;
                    jQuery.post(WHMPAjax.ajaxurl, {'params':".json_encode($params).",'domain':'{$_GET["search_domain"]}','action':'whmpress_action','do':'loadWhoisPage','skip_extra':'$search_extensions','page':whmp_page,'searchonly':'{$searchonly}','lang':'".$the_lang."'}, function(data){
                        jQuery(\"#waiting_div\").remove();
                        jQuery(\".result-div\").append(data);
                    });
                });
            });
            </script>\n";
        } else {
            $str = "";
        }

        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}


function whmpress_domain_search_ajax_results_function($atts) {
/**
 * Displays whois search result submitted by whmpress_whois_search form
 * 
 * List of parameters
 * searchonly = * for all domain or get result only for specific extensions comma seperated
 * html_class = HTML class for wrapper
 */
    $params = shortcode_atts( array(
        'html_template' => '',
        'image' => '',
        'searchonly' => '*',
        'html_class' => 'whmpress whmpress_domain_search_ajax_results',
        'html_id' => '',
        "whois_link" => whmpress_get_option("dsar_whois_link"), // "yes",
        "www_link" => whmpress_get_option("dsar_www_link"), //"yes",
        "disable_domain_spinning" => whmpress_get_option("dsar_disable_domain_spinning"),
        "order_landing_page" => whmpress_get_option("dsar_order_landing_page"),
        "show_years" => whmpress_get_option("dsar_show_years"),
        "show_price" => whmpress_get_option("dsar_show_years"),
        "search_extensions" => whmpress_get_option("dsa_search_extensions"),
    ), $atts );
    extract( $params );

    # Checking for parameters
    $the_lang = "";
    $SD = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
    if ($SD=="") $SD = isset($_GET["domain"])?$_GET["domain"]:"";
    $JavaCodes = "<script>jQuery(function(){
        jQuery.post(WHMPAjax.ajaxurl, {'show_price':'$show_price','show_years':'$show_years','order_landing_page':'$order_landing_page','disable_domain_spinning':'$disable_domain_spinning','search_domain':'{$SD}','domain':jQuery('#search_box').val(),'action':'whmpress_action','www_link':'$www_link','whois_link':'$whois_link','do':'getDomainData','searchonly':'{$searchonly}','skip_extra':'$search_extensions','page':'1','lang':'".$the_lang."'}, function(data){
            jQuery(\"#search_result_div\").html(data);
        });
        jQuery(document).on('click', \"#load-more-div button\", function () {
            jQuery(\"#load-more-div\").remove();
            jQuery(\".result-div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"fa fa-spinner fa-spin\"></i></div>');
            whmp_page++;
            jQuery.post(WHMPAjax.ajaxurl, {'params':".json_encode($params).",'show_price':'$show_price','show_years':'$show_years','order_landing_page':'$order_landing_page','disable_domain_spinning':'$disable_domain_spinning','domain':jQuery('#search_box').val(),'action':'whmpress_action','do':'loadWhoisPage','www_link':'$www_link','whois_link':'$whois_link','skip_extra':'$search_extensions','page':whmp_page,'searchonly':'{$searchonly}','lang':'".$the_lang."'}, function(data){
                jQuery(\"#waiting_div\").remove();
                jQuery(\".result-div\").append(data);
            });
        });
    });
    </script>\n";
    
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search_ajax_results");
    
    ## Instructions create a div in html template file with id search_result_div
    if ( is_file($html_template) ) {
        $vars = array(
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search_ajax_results");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
                
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $JavaCodes."\n\n".$OutputString;
    } else {
        if (isset($_REQUEST["search_domain"])) {
            $str = '<div style="clear:both"></div><div id="search_result_div">'."\n";
            $str .= '<div style="font-size:30px;text-align: center;">'."\n";
            $str .= '<i class="fa fa-spinner fa-spin"></i>'."\n";
            $str .= "</div>\n";
            $str .= "</div>\n";
            
            if (isset($_GET["ext"])) $_REQUEST["search_domain"] .= $_GET["ext"];
            
        } else {
            $str = "";
        }
        
        $str .= $JavaCodes;

        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}

function whmpress_pricing_table_function( $atts, $content = null ) {
/**
 * Shows pricing table
 * 
 * List of parameters
 * html_template = HTML template file path
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 * billingcycle = Billing cycle e.g. annually, monthly etc.
 * show_price = Display price or not.
 * show_combo = Show combo or not, No, Yes
 * show_button = Show submit button or not
 * currency = Currency for price
 */
    $result = include (WHMP_PLUGIN_DIR."/includes/shortcodes/whmpress_pricing_table.php");
    return $result;
}

function whmpress_price_box_function($atts) {
/**
 * Shows price box
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 * billingcycle = Billing cycle e.g. annually, monthly etc.
 * show_price = Display price or not.
 * show_combo = Show combo or not, No, Yes
 * show_button = Show submit button or not
 * currency = Currency for price
 */

    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'id' => '0',
        'billingcycle' => whmpress_get_option("pt_billingcycle"),
        'show_price' => whmpress_get_option("pt_show_price"),
        'show_combo' => whmpress_get_option("pt_show_combo"),
        'show_button' => whmpress_get_option("pt_show_button"),
        'currency' => '0',
        "button_text" => whmpress_get_option("pt_button_text"),
        "show_description" => "yes",
        'html_id' => '',
        'html_class' => 'whmpress whmpress_price_box',
        'show_discount' => whmpress_get_option('combo_show_discount'),
        'discount_type' => whmpress_get_option('combo_discount_type'),
        //"button_html_template" => "",
	), $atts ) );
    $currency = whmp_get_currency($currency);
    $button_text = __($button_text, "whmpress");
    
    # Getting data from MySQL
    global $wpdb;
    $Q = "SELECT `name`,`description` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $row = $wpdb->get_row($Q,ARRAY_A);
    
    # Check if price is requested or not
    if (strtolower($show_price)=="yes") {
        $price = whmpress_price_function( array("id"=> $id, "billingcycle" => $billingcycle, "currency" => $currency) );
    } else $price = "";
    $simple_price = $price;

    
    # Setting up description
    $description = trim(strip_tags($row["description"]),"\n");
    $description = explode("\n",$description);
    $description = "<ul>\n<li>". implode("</li><li>",$description). "</li>\n</ul>";
    
    # Check if combo is requested or not
    if (strtolower($show_combo)=="yes") {
        $combo = whmpress_order_combo_function( array(
                                                "id"=>$id,
                                                "show_button"=>"No",
                                                "currency"=>$currency,
                                                "discount_type"=>$discount_type,
                                                "show_discount"=>$show_discount,
                                                ) );
    } else $combo = "";
    
    # Check if button is requested or not
    if (strtolower($show_button)=="yes") {
        $button = whmpress_order_button_function( array("id"=>$id, "button_text"=>$button_text) );   // "html_template"=>$button_html_template
    } else $button = "";
    
    # Generating OutputString
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_price_box");
    
    if ( is_file($html_template) ) {        
        $decimal_sperator = get_option('decimal_replacement',".");
        $price1 = whmpress_price_function( array("show_duration"=>"no", "id"=> $id, "billingcycle" => $billingcycle, "currency" => $currency, "prefix"=>"", "suffix"=>"") );
        $totay = explode($decimal_sperator,strip_tags($price1));
        $fraction = isset($totay[1])?$totay[1]:"";
        $amount1 = $totay[0];
        
        $duration = explode("/", strip_tags($simple_price));
        $duration = isset($duration[1])?$duration[1]:"";
        
        $vars = array(
            "product_name" => $row["name"],
            "product_price" => $price1, 
            "product_description" => $description, 
            "order_combo" => $combo,
            "order_button" => $button,
            "button_text" => $button_text,
            "order_button_text" => $button_text,
            "image" => $image,
            "prefix" => whmp_get_currency_prefix($currency),
            "suffix" => whmp_get_currency_suffix($currency),
            "amount" => $amount1,
            "fraction" => $fraction,
            "decimal" => $decimal_sperator,
            "duration" => $duration,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_price_box");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $OutputString = "<h3>".$row["name"]."</h3>";
        
        $OutputString .= "<div class='style1_wrapper'>";
            if (strtolower($show_description)=="yes") {
                $OutputString .= "<div style='float:left' class='style1_left'>
                    $description
                </div>";
            }
            $OutputString .= "
            <div style='float:right' class='style1_right'>
                <h2>$price</h2>
                $combo
                $button
            </div>
            <div style='clear:both'></div>
        </div>";
        
        # Returning output string with wrapper div
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>".$OutputString."</div>";
    }
}

function whmpress_description_function($atts) {
/**
 * Shows service description
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 * show_as = display result in ul, ol
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'html_id' => '',
        'html_class' => 'whmpress whmpress_description',
        'id' => '0',
        'show_as' => whmpress_get_option('dsc_description'),
	), $atts ) );
    
    # Getting data from mysql tables
    global $wpdb;
    $Q = "SELECT `description` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $ndescription = $description = $wpdb->get_var($Q);
    
    $ndescription = trim(strip_tags($ndescription),"\n");
    $ndescription = explode("\n",$ndescription);
    
    $smarty_array = array();
    foreach($ndescription as $line) {
        if (trim($line)<>"") {
            $data = array();
            $data["feature"] = $line;
            $totay = explode(":", $line);
            $data["feature_title"] = trim($totay[0]);
            $data["feature_value"] = isset($totay[1])?trim($totay[1]):"";
            
            $smarty_array[] = $data;
        }
    }
    
    # Checking show_as parameter
    if (strtolower($show_as)=="ul" || strtolower($show_as)=="ol") {
        $description = trim(strip_tags($description),"\n");
        $description = explode("\n",$description);        
        $description = "<".$show_as.">\n<li>". implode("</li><li>",$description). "</li>\n</".$show_as.">";
    }
    
    # Generating output string
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_description");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "product_description" => $description,
            "data" => $smarty_array,
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_description");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        $OutputString = "<div $CLASS $ID>".$description."</div>";
        
        # Returning output string
        return $OutputString;
    }
}

function whmpress_name_function($atts) {
/**
 * Shows service name
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'html_id' => '',
        'html_class' => '',
        'id' => '',
	), $atts ) );
    
    # Getting data from mysql tables
    global $wpdb;
    $Q = "SELECT `name` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $name = $wpdb->get_var($Q);
    
    # Generating output string
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_name");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "product_name" => $name
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_name");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        $OutputString = "<div $CLASS $ID>".$name."</div>";
        
        # Returning output string
        return $OutputString;
    }
}

function whmpress_price_function($atts, $content=null) {
    //show_array($atts);
/**
 * Shows currency with prefix and suffix
 * 
 * List of parameters
 * currency = provide currency code
 * id = relid from mysql pricing table
 * html_class = html class name for wrapper
 * html_id = html id name for wrapper
 * billingcycle = select this column name from mysql pricing table
 * decimals = round number of decimals for price/amount
 * decimals_tag = html tag name for wrap decimals only
 * hide_decimal = yes for hide decimal symbol
 * prefix = show currency prefix, yes for show without any tag aur tag name to wrap.
 * suffix = show currency suffix, yes for show without any tag aur tag name to wrap.
 * show_duration = yes for show duration with price > Yes, No or tagname e.g. i
 * show_duration_as = long or short duration (year or yr)
 * convert_monthly = convert price into monthly price (yes or no)
 */    
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'currency' => whmpress_get_option("price_currency"),
        'html_class' => 'whmpress whmpress_price',
        'id' => '0',
        'billingcycle' => whmpress_get_option("billingcycle"),
        'price_type' => whmpress_get_option('price_type'),                # price, setup, both or total
        'decimals' => whmpress_get_option("decimals"),
        'decimals_tag' => whmpress_get_option("decimals_tag"),
        'hide_decimal' => whmpress_get_option("hide_decimal"),
        'prefix' => whmpress_get_option("prefix"),
        'suffix' => whmpress_get_option("suffix"),
        'html_id' => '',
        'show_duration' => whmpress_get_option("show_duration"),
        'show_duration_as' => whmpress_get_option("show_duration_as"),
        'convert_monthly' => whmpress_get_option("convert_monthly"),
        "config_option_string" => whmpress_get_option("config_option_string"),
        "configureable_options" => whmpress_get_option("configureable_options"),
        "price_tax" => whmpress_get_option("price_tax"),
        "no_wrapper" => "",
	), $atts ) );
    if (empty($currency)) $currency = whmp_get_currency($currency);
    $class = $html_class;
    
    # Getting WordPress DB variable for communicating with DB.
    global $wpdb;
    
    # Getting price from DB
    $Q = "SELECT `{$billingcycle}`,`paytype`,`monthly`, `msetupfee`, `qsetupfee`, `ssetupfee`, `asetupfee`, `bsetupfee`, `tsetupfee`, `tax` FROM `".whmp_get_pricing_table_name()."` prc,`".whmp_get_products_table_name()."` prds WHERE prds.`id`='{$id}' AND prc.`relid`='{$id}' AND prc.`currency`='{$currency}' AND prc.`type`='product'";
    $row = $wpdb->get_row($Q,ARRAY_A);
    if ($row["paytype"]=="free") $price = 0;
    else if ($row["paytype"]=="onetime") $price = $row["monthly"];
    else $price = $row[$billingcycle];
    
    if (strtolower(trim($price_type))=="setup") $price = $row[ substr($billingcycle,0,1)."setupfee"  ];
    elseif (strtolower(trim($price_type))=="total" || strtolower(trim($price_type))=="both") $price += $row[ substr($billingcycle,0,1)."setupfee"  ];
    
    # Checking that ID is valid or not
    if ($price===null || is_null($price)) return "Invalid ID ($id) or Invalid Currency ($currency)";
    
    # Getting price from configureable options.
    $config_price = null;
    if (whmp_is_table_exists(get_mysql_table_name("tblpricing")) && 
    whmp_is_table_exists(get_mysql_table_name("tblproductconfiglinks")) &&
    whmp_is_table_exists(get_mysql_table_name("tblproductconfigoptions")) &&
    whmp_is_table_exists(get_mysql_table_name("tblproductconfigoptionssub")) &&
    ($configureable_options=="1" OR strtolower($configureable_options)=="yes")
    ) {
        $Q = "SELECT SUM(`price`) FROM
        (SELECT MIN(`{$billingcycle}`) price, abc.configid  FROM `".get_mysql_table_name("tblpricing")."`,
        
        
        (SELECT tpcos.`configid`, tpcos.id id FROM `".get_mysql_table_name("tblpricing")."` p, `".get_mysql_table_name("tblproductconfiglinks")."` pcl, `".get_mysql_table_name("tblproductconfigoptions")."` tpco, 
        `".get_mysql_table_name("tblproductconfigoptionssub")."` tpcos WHERE 
        (tpco.optiontype='1' OR tpco.optiontype='2') AND
        p.`type`='product' AND p.relid=pid AND pcl.gid=tpco.gid AND tpco.id=tpcos.configid AND p.currency='{$currency}') abc
        
        WHERE `type`='configoptions' AND `currency`='{$currency}' AND `relid` IN
        (SELECT tpcos.id relid FROM `".get_mysql_table_name("tblpricing")."` p, `".get_mysql_table_name("tblproductconfiglinks")."` pcl, `".get_mysql_table_name("tblproductconfigoptions")."` tpco, `".get_mysql_table_name("tblproductconfigoptionssub")."` tpcos WHERE `relid`='{$id}' AND p.`type`='product' AND p.relid=pid AND pcl.gid=tpco.gid AND tpco.id=tpcos.configid AND p.currency='{$currency}')
        
        AND abc.id=`relid`
        GROUP BY `configid`) theR";
        
        $config_price1 = $wpdb->get_var($Q);
        
        
        $Q = "SELECT SUM(`price`*qtyminimum ) FROM
        (SELECT MIN(`{$billingcycle}`) price, abc.configid, abc.qtyminimum FROM `".get_mysql_table_name("tblpricing")."`,
        
        (SELECT tpco.qtyminimum, tpcos.`configid`, tpcos.id id FROM `".get_mysql_table_name("tblpricing")."` p, `".get_mysql_table_name("tblproductconfiglinks")."` pcl, `".get_mysql_table_name("tblproductconfigoptions")."` tpco, 
        `".get_mysql_table_name("tblproductconfigoptionssub")."` tpcos WHERE 
        p.`type`='product' AND p.relid=pid AND pcl.gid=tpco.gid AND tpco.id=tpcos.configid AND p.currency='{$currency}' AND `optiontype`='4') abc
        
        WHERE `type`='configoptions' AND `currency`='{$currency}' AND `relid` IN
        (SELECT tpcos.id relid FROM `".get_mysql_table_name("tblpricing")."` p, `".get_mysql_table_name("tblproductconfiglinks")."` pcl, `".get_mysql_table_name("tblproductconfigoptions")."` tpco, `".get_mysql_table_name("tblproductconfigoptionssub")."` tpcos WHERE `relid`='{$id}' AND p.`type`='product' AND p.relid=pid AND pcl.gid=tpco.gid AND tpco.id=tpcos.configid AND p.currency='{$currency}' AND `optiontype`='4')
        
        AND abc.id=`relid`
        GROUP BY `configid`) theR";
        
        $config_price2 = $wpdb->get_var($Q);
        
        $config_price = $config_price1 + $config_price2;
        
        $price += $config_price;
    }
    
    # Calculating tax.
    $TaxEnabled = $wpdb->get_var("SELECT `value` FROM ". whmp_get_configuration_table_name() ." WHERE `setting`='TaxEnabled'");
    $tax_amount = $base_price = 0;
    // If product tax is enabled and Configuration tax is enabled then execute these codes.
    if (strtolower($TaxEnabled)=="on" && $row["tax"]=="1") {
        $TaxType = $wpdb->get_var("SELECT `value` FROM ". whmp_get_configuration_table_name() ." WHERE `setting`='TaxType'");
        $TaxL2Compound = $wpdb->get_var("SELECT `value` FROM ". whmp_get_configuration_table_name() ." WHERE `setting`='TaxL2Compound'");
        
        $level1_rate = $wpdb->get_var("SELECT `taxrate` FROM `". whmp_get_tax_table_name()."` WHERE `level`='1' AND `country`='' ORDER BY `id`" );
        $level2_rate = $wpdb->get_var("SELECT `taxrate` FROM `". whmp_get_tax_table_name()."` WHERE `level`='2' AND `country`='' ORDER BY `id`" );
        
        $taxes = whmpress_calculate_tax($price);
        $base_price = $taxes["base_price"];
        $tax_amount = $taxes["tax_amount"];
        /*if ( $TaxType=="Exclusive") {
            $tax_amount = $price * ($level1_rate / 100);
            $base_price = $price;
        } elseif ( $TaxType=="Inclusive") {
            $tax_amount = ($price / (100 + $level1_rate )) * $level1_rate;
            $base_price = $price - $tax_amount;
        }
        
        if (!empty($level2_rate)) {
            if ( strtolower($TaxL2Compound)=="on")
                $price2 = $tax_amount + $base_price;
            else
                $price2 = $base_price;
            
            $tax2_amount = 0;
            if ( $TaxType=="Exclusive") {
                $tax2_amount = $price2 * ($level2_rate / 100);
            } elseif ( $TaxType=="Inclusive") {
                $tax2_amount = ($price2 / (100 + $level2_rate )) * $level2_rate;
            }
            $tax_amount += $tax2_amount;
        }*/
    } else {
        $tax_amount = 0;
        $base_price = $price;
    }
    
    if ($price_tax=="default") $price_tax="";
    $price_tax = trim(strtolower($price_tax));
    if ($price_tax=="exclusive") $price = $base_price;
    elseif ($price_tax=="inclusive") $price = $base_price + $tax_amount;
    elseif ($price_tax=="tax") $price = $tax_amount;
    
    $simple_price = $price;
    
    # Converting price into monthly price if required
    if ( $row["paytype"]=="recurring" ) {
        if (strtolower($convert_monthly)=="yes" && $billingcycle=="annually") $price = $price/12;
        elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="quarterly") $price = $price/3;
        elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="semiannually") $price = $price/6;
        elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="biennially") $price = $price/24;
        elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="triennially") $price = $price/36;
    }
    
    # Setting decimals for price
    if (get_option("show_trailing_zeros")=="yes")
        $price = number_format($price, $decimals);
    else
        $price = round($price, $decimals);

    $parts = explode(".",$price);
    if ($decimals>0) {
        $pt1 = isset($parts[1])?$parts[1]:"";
        if ($decimals_tag=="-" || trim($decimals_tag)=="")
            $parts[1] = ".".($pt1);
        else
            $parts[1] = "<{$decimals_tag}>." . ($pt1) . "</{$decimals_tag}>";
    }
    else
        $parts[1] = "";
    $price = (isset($parts[0])?$parts[0]:"") . (isset($parts[1])?$parts[1]:"");
    $price = rtrim($price,".");
    
    # Remove decimal symbol if requested
    if (strtolower($hide_decimal)=="yes") {
        $price = str_replace(".","",$price);
    }
    
    # Check show duration parameter check
    $BillingCycles = array("annually","monthly","free","onetime");
    $ReplaceLongBillingCycles = array("year","month","free","onetime");
    $ReplaceShortBillingCycles = array("yr","mo","fe","ot");
    
    $return_string = "";
    if (strtolower($prefix)=="-") {
        $return_string .= whmp_get_currency_prefix($currency);
    } elseif (strtolower($prefix)<>"" && strtolower($prefix)<>"no") {
        $return_string .= "<{$prefix}>".whmp_get_currency_prefix($currency)."</{$prefix}>";
    }
    $return_string .= $price;
    if (strtolower($suffix)=="-") $return_string .= whmp_get_currency_suffix($currency);
    elseif (strtolower($suffix)<>"" && strtolower($suffix)<>"no") $return_string .= "<{$suffix}>".whmp_get_currency_suffix($currency)."</{$suffix}>";
    
    if (strtolower($show_duration_as)=="short") {
        if ($row["paytype"]=="recurring") $ShowedBillingCycle = str_replace($BillingCycles,$ReplaceShortBillingCycles,$billingcycle);
        elseif ($row["paytype"]=="free")  $ShowedBillingCycle = "";
        elseif ($row["paytype"]=="onetime")  $ShowedBillingCycle = "Ot";
    } else {
        if ($row["paytype"]=="recurring") $ShowedBillingCycle = str_replace($BillingCycles,$ReplaceLongBillingCycles,$billingcycle);
        elseif ($row["paytype"]=="free")  $ShowedBillingCycle = "Free";
        elseif ($row["paytype"]=="onetime")  $ShowedBillingCycle = "One Time";
    }
    
    if ($row["paytype"]=="recurring") {
        if (strtolower($convert_monthly)=="yes" && $show_duration_as=="short") $ShowedBillingCycle = "mo";
        elseif (strtolower($convert_monthly)=="yes") $ShowedBillingCycle = "month";
    }
    
    if ($ShowedBillingCycle=="") $show_duration = "no";
    if ($row["paytype"]=="onetime") $show_duration = "no";
    
    # 
    if ($row["paytype"]=="free") {
        $billingcycle = "free";
    } else if ($row["paytype"]=="onetime") {
        $billingcycle = "onetime";
    }
    
    # Generating string for output
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_price");
    
    if ( is_file($html_template) ) {
        $decimal_sperator = get_option('decimal_replacement',".");
        $totay = explode($decimal_sperator,strip_tags($simple_price));
        $amount1 = $totay[0];
        $fraction = isset($totay[1])?$totay[1]:"";
        $totay = explode("/", strip_tags($price));
        $duration = @$totay[1];
        
        if (strtolower($show_duration_as)=="short") {
            if ($row["paytype"]=="recurring") $duration = str_replace($BillingCycles,$ReplaceShortBillingCycles,$billingcycle);
            elseif ($row["paytype"]=="free")  $duration = "";
            elseif ($row["paytype"]=="onetime")  $duration = "Ot";
        } else {
            if ($row["paytype"]=="recurring") $duration = str_replace($BillingCycles,$ReplaceLongBillingCycles,$billingcycle);
            elseif ($row["paytype"]=="free")  $duration = "Free";
            elseif ($row["paytype"]=="onetime")  $duration = "One Time";
        }
        
        if (strtolower($show_duration)=="-") {
            $return_string = $return_string."/{$ShowedBillingCycle}";
        } elseif (strtolower($show_duration)=="no") {
            $return_string = $return_string;
        } elseif (strtolower($show_duration)<>"no" && $show_duration<>"")
            $return_string = $return_string."<{$show_duration}>/{$ShowedBillingCycle}</{$show_duration}>";
        
        $vars = array(
            "product_price" => $return_string,
            "prefix" => whmp_get_currency_prefix($currency),
            "suffix" => whmp_get_currency_suffix($currency),
            "amount" => $amount1,
            "fraction" => $fraction,
            "decimal" => $decimal_sperator,
            "duration" => $duration,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_price");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        if (strtolower($show_duration)=="-") {
            if ($no_wrapper=="1" || strtolower($no_wrapper)=="yes") $return_string = $return_string."/{$ShowedBillingCycle}";
            else $return_string = "<span class='$class' id='{$html_id}'>".$return_string."/{$ShowedBillingCycle}</span>";
        } elseif (strtolower($show_duration)=="no") {
            if ($no_wrapper=="1" || strtolower($no_wrapper)=="yes") $return_string = $return_string;
            else $return_string = "<span class='$class' id='{$html_id}'>".$return_string."</span>";
        } elseif (strtolower($show_duration)<>"no" && $show_duration<>"") {
            if ($no_wrapper=="1" || strtolower($no_wrapper)=="yes") $return_string = $return_string."<{$show_duration}>/{$ShowedBillingCycle}</{$show_duration}>";
            else $return_string = "<span class='$class' id='{$html_id}'>".$return_string."<{$show_duration}>/{$ShowedBillingCycle}</{$show_duration}></span>";
        }
        
        # Returning output string
        $decimal_sperator = get_option('decimal_replacement',".");
        //var_dump($config_price);
        if (!is_null($config_price)) {
            //$config_option_string
        } else {
            $config_option_string = "";
        }
        
        if (trim($config_option_string)=="")
            return str_replace(".",$decimal_sperator,$return_string);
        else
            return $config_option_string." ".str_replace(".",$decimal_sperator,$return_string);
    }
}


function whmpress_order_combo_function($atts, $content=null) {
/**
 * Displays price of a WHMCS Service (Hosting Plan) for all billing cycle in dropdown list along with optional order button. Service id is the only required parameters
 * 
 * List of parameters
 * decimals = round number of decimals for price/amount
 * id = relid from mysql pricing table
 * currency = provide currency code
 * rows = How many rows for combo and button 1 or 2
 * show_discount = Whether to show discount or not
 * show_button = Show HTML button or not yes or no
 * button_text = HTML button text
 * combo_class = HTML class name for combo
 * button_class = HTML class for button
 * html_id = html id name for wrapper
 * html_class = HTML class name for wrapper
 * discount_type = What discout type required. yearly, monthly, quarterly etc.
 * billingcycles = What columns will display in combo e.g. yearly,monthly,biennially,semiannually,quarterly
 * prefix = show currency prefix, yes for show prefix
 * suffix = show currency suffix, yes for show suffix
 */
 
    $OutputString = include WHMP_PLUGIN_DIR."/includes/shortcodes/whmpress_order_combo.php";
    return $OutputString;
}

function whmpress_order_button_function($atts) {
/**
 * Displays order button
 * 
 * List of parameters
 * button_text = Button text
 * html_class = HTML class for button
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * html_id = HTML id for button
 * currency = Currency ID
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'button_text' => whmpress_get_option('ob_button_text'),
        'html_class' => 'whmpress whmpress_order_button',
        'id' => '0',
        'billingcycle' => whmpress_get_option('ob_billingcycle'),
        'html_id' => '',
        'currency' => '0',
        "params" => '',
	), $atts ) );
    if (empty($currency)) $currency = whmp_get_currency($currency);
    $value = $button_text;
    $class = $html_class;
    
    # Generating URL.
    if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
        global $WHMPress_Client_Area;
        if (empty($WHMPress_Client_Area)) $WHMPress_Client_Area = new WHMPress_Client_Area;
        if ($WHMPress_Client_Area->is_permalink()) {
            $url = rtrim(WHMPress::get_whmcs_url("order"),"/")."/pid/{$id}/a/add/currency/{$currency}/billingcycle/{$billingcycle}/";
        } else {
            $url = WHMPress::get_whmcs_url("order")."pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
        }
    } else {
        $url = WHMPress::get_whmcs_url("order")."pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
    }
        
    if ($params<>"") $url .= "&".$params;
    
    $parsed_url = parse_url($url);
    if (isset($parsed_url["query"])) {
        
    }
    
    # Generating output string.
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_order_button");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "product_order_button" => "<button type='button' id='$html_id' class=\"{$class}\" onclick=\"window.location.href='{$url}'\">{$value}</button>",
            "button_text" => $button_text,
            "order_button_text" => $button_text,
            "url" => $url,
            "product_order_url" => $url,
        );

        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_order_button");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $str = "<button type='button' id='$html_id' class=\"{$class}\" onclick=\"window.location.href='{$url}'\">{$value}</button>";
        
        # Returning output string
        return $str;
    }
}

function whmpress_order_link_function($atts) {
/**
 * Displays order link
 * 
 * List of parameters
 * link_text = Link text
 * html_class = HTML class for link
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * html_id = HTML id for link
 * currency = Currency ID
 */

    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'link_text' => whmpress_get_option("Link Text"),
        'html_class' => 'whmpress_order_link',
        'id' => '0',
        'billingcycle' => 'annually',
        'html_id' => '',
        'currency' => ''
	), $atts ) );
    $value = $link_text;
    $class = $html_class;
    $currency = whmp_get_currency($currency);
    
    # Generating URL.    
    if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
        global $WHMPress_Client_Area;
        if (empty($WHMPress_Client_Area)) $WHMPress_Client_Area = new WHMPress_Client_Area;
        if ($WHMPress_Client_Area->is_permalink()) {
            $url = WHMPress::get_whmcs_url("order")."/pid/{$id}/a/add/currency/{$currency}/billingcycle/{$billingcycle}/";
        } else {
            $url = WHMPress::get_whmcs_url("order")."pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
        }
    } else {
        $url = WHMPress::get_whmcs_url("order")."pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
    }
        
    
    # Generating output string.
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_order_link");
    
    if ( is_file($html_template) ) {
        
        $vars = array(
            "product_order_url" => $url,
            "product_link_text" => $link_text,
            "product_order_link" => "<a href=\"{$url}\">{$link_text}</a>",
        );
                
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_order_link");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        $str = "<a id='$html_id' class=\"{$class}\" href=\"{$url}\">{$value}</a>";
        
        # Returning output string
        return $str;
    }
}


function whmpress_order_url_function( $atts ) {
/**
 * Display/Generate order url
 * 
 * List of parameters
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * currency = Currency ID
 */
    extract( shortcode_atts( array(
        'html_template' => '',
        'id' => whmp_get_installation_url(),
        'billingcycle' => 'annually',
        'currency' => ''
	), $atts ) );
    $currency = whmp_get_currency($currency);    

    # Generating order url and making output string    
    if (is_plugin_active( 'WHMpress_Client_Area/client-area.php' )) {
        global $WHMPress_Client_Area;
        if (empty($WHMPress_Client_Area)) $WHMPress_Client_Area = new WHMPress_Client_Area;
        if ($WHMPress_Client_Area->is_permalink())
            $str = WHMPress::get_whmcs_url("order")."/a/add/pid/".$id."/currency/".$currency."/billingcycle/{$billingcycle}/";
        else
            $str = WHMPress::get_whmcs_url("order")."a=add&pid=".$id."&currency=".$currency."&billingcycle={$billingcycle}";
    } else {
        $str = WHMPress::get_whmcs_url("order")."a=add&pid=".$id."&currency=".$currency."&billingcycle={$billingcycle}";
    }
    $WHMPress = new WHMPress;
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_order_url");
    if ( is_file($html_template) ) {
        $vars = array(
            "product_order_url" => $str,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_order_url");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        return $str;
    }
    
    # Returning output string
}

function whmpress_currency_function($atts) {
/**
 * Display currency symbol
 * 
 * List of attributes/parameters
 * html_id = HTML id for wrapper span
 * html_class = HTML class for wrapper span
 * show = suffix,prefix,code    (default prefix)
 */

    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'html_id' => '',
        'html_class' => 'whmpress_currency',
        'show' => 'prefix',
        'currency' => ''
	), $atts ));
    $currency = whmp_get_currency($currency);
    
    # Getting currency
    $func = "whmp_get_currency_".strtolower($show);
    $currency = $func($currency);
    /*
    if (!isset($_SESSION["currency"])) {
        $func = "whmp_get_default_currency_".strtolower($show);
        $currency = $func();
    } else {
        $func = "whmp_get_currency_".strtolower($show);
        $currency = $func($_SESSION["currency"]);
    }*/
    
    # Returning output including wrapper
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_currency");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "current_currency" => $currency
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_currency");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        return "<span id='$html_id' class='$html_class'>" . $currency . "</span>";
    }
}

function whmpress_currency_combo_function($atts) {
/**
 * Generate a currency combo and will change currency for prices
 * 
 * List of parameters
 * combo_name = HTML name for combo
 * combo_class = HTML class for combo
 * prefix = Display or not prefix with currency, e.g. $
 * html_id = HTML id for wrapper of combo
 * html_class = HTML class for wrapper of combo
 */
 
    extract( shortcode_atts( array( 
		'html_template' => '',
        'image' => '',
        'combo_name' => '',
        'combo_class' => '',
        'prefix' => 'yes',
        'html_id' => '',
        'html_class' => 'whmpress whmpress_currency_combo'
	), $atts ));
    $name = $combo_name;
    $class = $combo_class;
    
    # Getting WordPress DB object
    global $wpdb;
    
    # Checking currency
    if (!session_id()) session_start();
    if (isset($_SESSION["currency"])) $currency=$_SESSION["currency"];
    else {
        $currency = whmp_get_default_currency_id();
    }
    
    # getting ajax url which will change currency in session
    #$ajaxFile = WHMP_PLUGIN_URL."/includes/set_currency.php";
    
    # Generating random HTML id for combo
    $myID = "S".rand();
    
    # Generating Output HTML
    $str = "
    <script>
        jQuery(function(){
        jQuery(\"#{$myID}\").change(function(){
            val = jQuery(this).val();
            jQuery.post(WHMPAjax.ajaxurl + '?setCurrency',{'curency': val,'action':'whmpress_action'},function(data){
                if (data=='OK')
                    window.location.reload();
                else
                    alert(data);
            });
        });
    });
    </script>
    ";
    $str .= "<select id='$myID'";
    $str .= ' class="'.$class.'"';
    $str .= ' name="'.$name.'"';
    $str .= ">\n";
    
    $C = $currency;
    $Q = "SELECT `id`, `prefix`, `code` FROM `".whmp_get_currencies_table_name()."` ORDER BY `id`";
    $rows = $wpdb->get_results($Q);
    $smarty_array = array();
    foreach($rows as $row) {
        $data = array();
        $S = $C==$row->id?"selected=selected":"";
        $str .= "<option $S value='{$row->id}'>{$row->code}";
        if (strtolower($prefix)=="yes") $str .= " ({$row->prefix})";        
        $str .= "</option>";
        
        $data["prefix"] = $row->prefix;
        $data["code"] = $row->code;
        $data["id"] = $row->id;
        $smarty_array[] = $data;
    }
    $str .= "</select>";
    
    # Returning combo output string including wrapper div
    $decimal_sperator = get_option('decimal_replacement',".");
    
    # Generating output string
    $WHMPress = new WHMPress;
    
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_currency_combo");
    
    if ( is_file($html_template) ) {
        $OutputString = $WHMPress->read_local_file($html_template);
        $vars = array(
            "currency_combo" => str_replace(".",$decimal_sperator,$str),
            "data" => $smarty_array,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_currency_combo");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        return "<div id='$html_id' class='$html_class'>" . str_replace(".",$decimal_sperator,$str) . "</div>";
    }
}

function whmpress_currency_combo_fancy_function() {
    if (!session_id()) session_start();
    if (isset($_SESSION["currency"])) $currency=$_SESSION["currency"];
    else {
        $currency = whmp_get_default_currency_id();
    }
    
    // Getting currencies
    global $wpdb;
    $Q = "SELECT `id`, `prefix`, `code` FROM `".whmp_get_currencies_table_name()."` ORDER BY `id`";
    $rows = $wpdb->get_results($Q,ARRAY_A);
    #print_r ($rows);
    
    // Adding flag if flag png available in extra folder
    foreach($rows as &$row) {
        if (is_file(WHMP_PLUGIN_DIR."/extras/".$row["code"].".png"))
            $row["flag"] = WHMP_PLUGIN_URL."/extras/".$row["code"].".png";
        else
            $row["flag"] = WHMP_PLUGIN_URL."/extras/noflag.png";
    }
    
    // Setting current selected currency
    $topurl = "";
    foreach($rows as $r) {
        #print_r ($row);
        if ($currency==$r["id"]) {
            $topurl = '<a class="lang_sel_sel icl-en" href="#" onclick="return false;"><img title="'.
            $r["code"].
            ' ('.
            $r["prefix"].
            ')" alt="en" src="'.
            $r["flag"].
            '" class="iclflag">&nbsp;<span class="icl_lang_sel_current">'.
            $r["code"].
            ' ('.
            $r["prefix"].
            ')</span></a>';
            #break;
        }
    }
    
    $func_name = uniqid('func_');
    $str = '
    <div id="lang_sel">
        <ul>
            <li>
                '.$topurl.'
                <ul>';
                foreach($rows as $row1) {
                    $str .= "<li class=\"icl-pl\"><a href=\"#\" onclick=\"return ".
                    $func_name.
                    "(".
                    $row1["id"].
                    ");\" hreflang=\"pkr\" rel=\"alternate\"><img title=\"{$row1["code"]}\" alt=\"{$row1["code"]}\" src=\"".
                    $row1["flag"].
                    "\" class=\"iclflag\">&nbsp; <span class=\"icl_lang_sel_native\">{$row1["code"]} ({$row1["prefix"]})</span> <span class=\"icl_lang_sel_translated\"><span class=\"icl_lang_sel_native\">(</span>{$row["code"]}<span class=\"icl_lang_sel_native\">)</span></span></a></li>\n";
                }
                $str .= '</ul>
            </li>
        </ul>
    </div>
    
    <script>
        function '.$func_name.'(cur) {
            jQuery.post(WHMPAjax.ajaxurl + "?setCurrency",{curency:cur,action:"whmpress_action"},function(data){
                if (data=="OK") window.location.reload();
                else alert(data);
            });
            return false;
        }
    </script>
    ';
    return $str;
}

function whmpress_domain_search_function($atts) {
    /**
     * Generates HTML form for search domains
     * 
     * List of parameters
     * show_tlds = provide comma seperated tlds e.g. .com,.net,.org or leave it blank for all tlds
     * show_tlds_wildcard = provide tld search as wildcard, e.g. pk for all .pk domains or co for all com and .co domains
     * show_combo = Yes or No for display or hide combo box of tlds
     * placeholder = HTML placeholder for input search box
     * text_class = HTML class for wrapper of input search box
     * combo_class = HTML class for wrapper of combo box
     * button_class = HTML class for wrapper of submit button of form
     * action = Specify url where form will submit
     * button_text = Button text for submit button
     * html_class = HTML class for wrapper of form
     * html_id = HTML id for wrapper of form
     */


    $params = shortcode_atts( array(
        'html_template' => '',
        'image' => '',
        'show_tlds' => '',
        'show_tlds_wildcard' => '',
        'show_combo' => whmpress_get_option('ds_show_combo'), //'no',
        'placeholder' => whmpress_get_option('ds_placeholder'),
        'text_class' => 'search_div',
        'combo_class' => 'select_div',
        'button_class' => 'submit_div',
        'action' => WHMPress::get_whmcs_url("domainchecker"),
        'button_text' => whmpress_get_option('ds_button_text'), //'Search',
        'html_class' => 'whmpress whmpress_domain_search',
        'html_id' => '',
    ), $atts);
    extract( $params );

    # Getting WordPress DB object
    global $wpdb;
    
    # Generating and setting combo box if it will display
    if (strtolower($show_combo)=="yes"):
        $Q = "SELECT `extension` FROM `".whmp_get_domain_pricing_table_name()."` WHERE 1";
        if ($show_tlds<>"") {
            $show_tlds = explode(",",$show_tlds);
            $Q .= " AND (`extension`='".implode("' OR `extension`='",$show_tlds)."')";
        } elseif ($show_tlds_wildcard<>"") {
            $Q .= " AND `extension` LIKE '%{$show_tlds_wildcard}%'";
        }
        $Q .= " ORDER BY `extension`";
        $rows = $wpdb->get_results($Q, ARRAY_A);
    endif;
    
    # Generating output string
    $ACTION = empty($action)?"":"action='$action'";
    $str = "<form method=\"get\" id=\"searchDomainForm\" $ACTION>";
    $params = parse_url($action);
    if (!isset($params["query"])) $params["query"] = "";
    if ($params["query"]<>"") {
        parse_str($params["query"], $params);
        foreach($params as $key=>$val)
            $str .= "<input type=\"hidden\" value=\"{$val}\" name=\"{$key}\">";
    }
    $str .= "<!--input type=\"hidden\" name=\"token\" value=\"24372f4f06ca835d9101d60a258c30a4c93b3bf7\">
    <input type=\"hidden\" name=\"direct\" value=\"true\"-->";
    $str .= "<div class=\"{$text_class} search_div\">";
    $val = isset($_GET["search_domain"])?$_GET["search_domain"]:"";
    $str .= "<input required='required' title='".__("Please fill out this field", "whmpress")."' type=\"search\" name=\"domain\" id=\"search_domain\" placeholder=\"".__($placeholder,"whmpress")."\" value=\"{$val}\" />\n";
    $str .= "</div>";
    
    $WHMPress = new WHMPress;
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_domain_search");
    
    $smarty_array = array();
    $smarty_array["params"] = $params;
    $smarty_array["params_encoded"] = json_encode($params);
    $smarty_array["class"] = $combo_class;
    $smarty_array["rows"] = array();
    if (strtolower($show_combo)=="yes") {
        $smarty_array["rows"] = $rows;
        $Combo = "<div class=\"{$combo_class} select_div\">";
        
        $Combo .= "<select name='ext'>";
        foreach($rows as $row) {
            $Combo .= "<option>".$row["extension"]."</option>\n";
        }
        $Combo .= "</select>";
        $Combo .= "</div>";
        if (!is_file($html_template)) {
            $str .= $Combo;
        }
    } else {
        $str .= "<input type='hidden' name='ext' value='' />\n";
    }
    $str .= "<div class=\"{$button_class} submit_div\">";
    $str.= "<input type=\"submit\" value=\"{$button_text}\">";
    $str .= "</div>";
    $str .= "</form>";
    
    
    if ( is_file($html_template) ) {
        $vars = array(
            "search_text_box" => "<input required='required' type=\"search\" name=\"domain\" id=\"search_domain\" placeholder=\"".__($placeholder,"whmpress")."\" value=\"{$val}\" />",
            "search_combo" => $Combo,
            "search_button" => "<input type=\"submit\" value=\"{$button_text}\">",
            "action_url" => $action,
            "combo_data" => $smarty_array,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_domain_search");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        
        # Returning output string including wrapper div
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $str . "</div>";
    }
}

function whmpress_price_table_domain_function($atts) {
    $html = include (WHMP_PLUGIN_DIR."/includes/shortcodes/whmpress_price_table_domain.php");
    return $html;
}

function whmpress_price_table_function($atts) {
/**
 * Displays price table of all services including domain
 * 
 * name = Matching service name
 * groups = comma seperated group names
 * billingcycles = Billing cycle names
 * decimals = number of decimals with price
 * type = type of product. e.g. product
 * table_id = HTML id for table
 * currency = Currency id for prices
 * show_hidden = provide yes if you want to show hidden products
 * replace_zero = replace zero with specific character, default is -
 * replace_empty = replace empty with specific character, default is x
 * html_id = HTML id for div wrapper
 * html_class = HTML class for div wrapper
 * hide_search = Yes or No for hide search
 * titles = Comman seprated titles for column titles
 * search_label = Set label for search
 * search_placeholder = Set placeholder for search box
 */
    
    extract( shortcode_atts( array(
        'html_template' => '', 
		'name' => '',
		'groups' => '',
		'billingcycles' => '',
        'hide_columns' => '',
		'decimals' => whmpress_get_option('pm_decimals'),
        'show_hidden' => whmpress_get_option('pm_show_hidden'),
        'replace_zero' => whmpress_get_option('pm_replace_zero'),
        'replace_empty' => whmpress_get_option('pm_replace_empty'),
        'table_id' => 'prices_table',
        'type' => 'product',
        'html_id' => '',
        'html_class' => 'whmpress whmpress_price_matrix',
        'hide_search' => whmpress_get_option('pm_hide_search'),
        'currency' => '',
        'titles' => '',
        'search_label' => whmpress_get_option('pm_search_label'),
        'search_placeholder' => whmpress_get_option('pm_search_placeholder'),
        'order_link' => '1',
        'data_table' => '0',
	), $atts ) );
    
    $cols = $billingcycles;
    $showhidden = $show_hidden;
    $replacezero = $replace_zero;
    $replaceempty = $replace_empty;
    if (!isset($currency)) $currency = "";
    $currency = whmp_get_currency($currency);
    
    # Checking parameters
    
    # Getting WordPress DB object
    global $wpdb;
    
    # Getting symbol type
    $symbol_type = strtolower(whmpress_get_option('default_currency_symbol'));
    
    # Setting fields/columns for Table
    $fieldss = array(
        "sr"=>__("Sr", "whmpress"),
        "id"=>__("ID", "whmpress"),
        "name"=>__("Name", "whmpress"),
        "groupn"=>__("Group", "whmpress"),
        "monthly"=>__("Monthly", "whmpress"),
        "quarterly"=>__("3 Months", "whmpress"),
        "semiannually"=>__("6 Months", "whmpress"),
        "annually"=>__("Yearly", "whmpress"),
        "biennially"=>__("2 Years", "whmpress"),
        "triennially"=>__("3 Years", "whmpress"),
    );
    
    $hide_columns = explode(",",$hide_columns);
    foreach($hide_columns as $hd) {
        if (strtolower($hd)=="group") $hd="groupn";
        $hd = trim($hd);
        if (isset($fieldss[$hd])) unset($fieldss[$hd]);
    }
    
    $dfieldss = array(          // Deletable fields
        "monthly"=>__("Monthly", "whmpress"),
        "quarterly"=>__("3 Months", "whmpress"),
        "semiannually"=>__("6 Months", "whmpress"),
        "annually"=>__("Yearly", "whmpress"),
        "biennially"=>__("2 Years", "whmpress"),
        "triennially"=>__("3 Years", "whmpress"),
    );
    $fields = "pd.`id`,pd.`name`,g.`name` groupn,pr.`monthly`,pr.`quarterly`,pr.`semiannually`,pr.`annually`,pr.`biennially`,pr.`triennially`,`gid`";
    if ($table_id=="") $table_id = uniqid();
    
    # Getting data from DB
    $Q = "SELECT $fields,pd.paytype FROM `".whmp_get_pricing_table_name()."` pr, `".whmp_get_products_table_name()."` pd, `".whmp_get_product_group_table_name()."` g
    WHERE pr.`currency`='$currency' AND pr.`relid`=pd.`id`";
    if ($name<>"") $Q .= " AND pd.`name` LIKE '%{$name}%'";
    if ($groups<>"") {
        $group = explode(",",$groups);
        $Q .= " AND (";
        foreach($group as $g) {
            if (is_numeric($g)) $Q .= "g.`id`='".$g."' OR ";
            else $Q .= "g.`name`='".$g."' OR ";
        }
        $Q = substr($Q,0,-4).")";
        //$Q .= " g.`name`='".implode("' OR g.`name`='",$group)."')";
    }
    
    if (strtolower($showhidden)=="no") $Q .= " AND pd.`hidden`='0' ";
    
    $Q .= " AND pd.gid=g.id AND pr.`type`='{$type}'
    ORDER BY pd.`gid`, pd.`name`";
    
    # Getting decimal seperator from settings
    $decimal_sperator = get_option('decimal_replacement',".");
    
    # Generating output string
    if ($cols<>"") {
        unset($fieldss["monthly"],$fieldss["quarterly"],$fieldss["semiannually"],$fieldss["annually"],$fieldss["biennially"],$fieldss["triennially"]);        
        $cols = explode(",",$cols);
        foreach($cols as $col) {
            $fieldss[trim($col)] = $dfieldss[trim($col)];
        }
    }
    
    if ($data_table=='1' || strtolower($data_table)=='yes') {
        $str = "<script>
        jQuery(function(){
            jQuery('table#{$table_id}').DataTable();
        });
        </script>\n";
    } else {
        $str = "<script>
        jQuery(function(){
            jQuery('input#search_price_table').quicksearch('table#{$table_id} tbody tr');
        });
        </script>\n";
    }
    
    $rows = $wpdb->get_results($Q,ARRAY_A);
    $str .= "<table style='width:100%' border='1' id='{$table_id}'>
    <thead>
        <tr>";
        if ($titles=="")
            $titles = array();
        else
            $titles = explode(",",$titles);
        $x=0;
        foreach($fieldss as $k=>$field) {
            if (isset($titles[$x])) {
                $t = trim($titles[$x]);
            } else {
                $t = trim($field,"`");
            }
            //$t = trim($field,"`");
            if ($k=="groupn") $k = "group";
            $smarty_title = $k."_title";
            $$smarty_title = $t;
            
            $str .= "<th>".$t."</th>";
            
            $x++;
        }
        // Show order link column
        if ($order_link=="1" || strtolower($order_link)=="yes") {
            $str .= "<th></th>";
        }
    $str .= "</tr>
    </thead>
    <tbody>\n";
    
    $smarty_array = array();
    foreach($rows as $key=>$row) {
        $data = array();
        $str .= "<tr>";
        if (!in_array("sr", $hide_columns)) {
            $str .= "<td data-content=\"Sr\">".($key+1)."</td>";
            $data["sr"] = $key+1;
        } else $data["sr"] = "";
            
        $x = 0;
        foreach($fieldss as $k=>$field) {
            if ($k<>"sr") {
                if (isset($titles[$x])) $t = trim($titles[$x]);
                else $t = trim($field,"`");
                if ($k=="id" || $k=="name" || $k=="groupn") {
                    $str .= "<td data-content=\"{$t}\">".$row[$k]."</td>";
                    
                    if ($k=="groupn")
                        $data["group"] = $row[$k];
                    else
                        $data[$k] = $row[$k];
                } elseif ( $row["paytype"]=="free" ) {
                    $v = "0";
                    if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency)."$v";
                    elseif ($symbol_type=="suffix") $v = "$v".whmp_get_currency_suffix($currency);
                    elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
                    $str .= "<td data-content=\"{$t}\">$v</td>";
                    $data[$k] = $v;
                } else {
                    $v = $row[$k];
                    if ($v=="0.00") $v=$replacezero;
                    if ($v=="-1.00") $v=$replaceempty;
                    if (is_numeric($v)) {
                        //$v=str_replace(".",$decimal_sperator,number_format($v,$decimals));                        
                        $v = whmpress_price_function( array(
                            "billingcycle"=>$k,
                            "id"=>$row["id"],
                            "currency"=>$currency,
                            "decimals"=>$decimals,
                            "show_duration"=>"no",
                            "convert_monthly"=>"no",
                            "html_id"=>"",
                            "html_class"=>"",
                            "decimals_tag"=>"",
                            "prefix"=>"no",
                            "suffix"=>"no",
                            "no_wrapper"=>"1",
                        ) );
                    }
                    if ($v<>$replaceempty) {
                        if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency)."$v";
                        elseif ($symbol_type=="suffix") $v = "$v".whmp_get_currency_suffix($currency);
                        elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
                    }
                    $str .= "<td data-content=\"{$t}\">".$v."</td>";
                    $data[$k] = $v;
                }
            }
            $x++;
        }
        
        $order_button = whmpress_order_button_function(array("id"=>$row["id"],"currency"=>$currency) );
        $data["order_url"] = $order_button;
        
        if ($order_link=="1" || strtolower($order_link)=="yes") {
            $str .= "<td>". $order_button ."</td>";
        }
        $str .= "</tr>\n";
        $smarty_array[] = $data;
    }
    $str .= "
    </tbody>
    </table>";
    
    $WHMPress = new WHMPress;
    $html_template = $WHMPress->check_template_file($html_template, "whmpress_price_matrix");
    
    if ( is_file($html_template) ) {
        $vars = array(
            "search_label" => $search_label,
            "search_text_box" => "<input id='whmpress_text_box' type='search' placeholder='".__($search_placeholder,"whmpress")."'>",
            "price_matrix_table" => $str,
            "sr_title" => $sr_title,
            "id_title" => $id_title,
            "name_title" => $name_title,
            "group_title" => $group_title,
            "monthly_title" => $monthly_title,
            "quarterly_title" => $quarterly_title,
            "semiannually_title" => $semiannually_title,
            "annually_title" => $annually_title,
            "biennially_title" => $biennially_title,
            "triennially_title" => $triennially_title,
            "data" => $smarty_array,
        );
        
        # Getting custom fields and adding in output
        $TemplateArray = $WHMPress->get_template_array("whmpress_price_matrix");
        foreach($TemplateArray as $custom_field) {
            $vars[$custom_field] = isset($atts[$custom_field])?$atts[$custom_field]:"";
        }
        
        $OutputString = whmp_smarty_template($html_template, $vars);
        return $OutputString;
    } else {
        # Adding search box if hide_search is not called
        $search_box = "";
        if (strtolower($hide_search)<>"yes") {
            if ($data_table=='1' || strtolower($data_table)=='yes') {
                // Do not include search box
            } else {
                $search_box = "
                <label>{$search_label}</label>
                <input type='search' placeholder='".__($search_placeholder,"whmpress")."' id='search_price_table' style='width:50%' >";
            }
        }
        
        # Returning output string including wrapper div
        $ID = !empty($html_id)?"id='$html_id'":"";
        $CLASS = !empty($html_class)?"class='$html_class'":"";
        return "<div $CLASS $ID>" . $search_box . $str . "</div>";
    }
}